<?
// ----------------------------------------------------------------------
// CUSTOMER-TOUCH CRM
// Copyright (C) 2003 by the Customer-Touch Development Team.
// http://www.customer-touch.com
// ----------------------------------------------------------------------
// Based on:
// CRM COMMERCIAL TRACKING TOOL - http://sourceforge.net/projects/crm-ctt/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html or
// take a look in the Doc directory
// ----------------------------------------------------------------------
// Original Author of this file: Alessandro Grassi
// ----------------------------------------------------------------------

session_start();
function tekenGrafiek($arrX, $arrY, $aankoopArr, $AreDates, $desc, $imgWidth, $imgHeight){
	global $title, $CRM_VERSION;
	//tijden
	$minX = getMinimum($arrX);
	$maxX = getMaximum($arrX);

	//waarden
	$minY = getMinimum($arrY);
	$maxY = getMaximum($arrY);

	
	$yDiff = $maxY - $minY;

	if ($yDiff == 0){
		$yDiff = 5;
	}
	$minY -= ($yDiff / 25);
	$maxY += ($yDiff / 25);
	$maxY = sprintf("%.2f", $maxY);

	$begintijd = strtotime($minX);
	$eindtijd = strtotime($maxX);

//		print strftime("%a", $begintijd);

//		print strftime("%T", $begintijd);

	$tijdSpan = $eindtijd - $begintijd;

	$xSpan = sizeof($arrX);
	$ySpan = $maxY - $minY;

	header ("Content-type: image/png");
	
	//$im = @ImageCreateFromPNG ("bg2.png"); // ACHTERGROND
	if (!$im) {
		$im = @ImageCreate ($imgWidth, $imgHeight) or die ("Cannot Initialize new GD image stream");		    
	}
	$firstColor = ImageColorAllocate ($im, 255, 255, 255);		// Eerste kleur moet wit zijn.

	$lineColor = ImageColorAllocate ($im, 254, 170, 87);		// Kleur van grafiek zelf
	$lineColorshadow = ImageColorAllocate ($im, 254, 254, 254);		// Kleur van grafiek zelf
//	$textcolor = ImageColorAllocate ($im, 254, 254, 254);		// Kleur van grafiek zelf
	$textColor = ImageColorAllocate ($im, 71, 72, 77);		// Kleur van de tekst
	$purColor  = ImageColorAllocate ($im, 0, 120, 0);		// Kleur van lijn aankoopprijs
	$gridColor = ImageColorAllocate ($im, 173, 184, 217);	// Kleur van het raster
	//$bgColor   = ImageColorAllocate ($im, 173, 184, 217);	// Achtergrondkleur
	$bgColor   = ImageColorAllocate ($im, 255, 255, 255);	// Achtergrondkleur	
//	$ShadowColor  = ImageColorAllocate ($im, 116, 129, 163);	// Achtergrondkleur
	$ShadowColor = ImageColorAllocate ($im, 180, 180, 180);		// Kleur van grafiek zelf

	if (sizeof($arrY) < 2){
		imagerectangle($im, 0, 0, $imgWidth - 1, $imgHeight - 1, $textColor);
		//ImageString ($im, 2, 25, 5, $desc, $textColor);
		imagestring($im, 5, 10, $imgHeight/2, "Error: insufficiant information to build graph", $textColor);
	}
	else{
		//if ($doTijd){
		
			$onderrand = imagefontwidth(1) * 11;
		
		$leftoffset= imagefontwidth(1) * strlen($maxY) + 5;
		
		imagefilledrectangle($im, $leftoffset,		0,	$imgWidth, 20,				$bgColor);	
		imagefilledrectangle($im, 0,		0,	$leftoffset, $imgHeight,				$bgColor);
		imagefilledrectangle($im, 0,		$imgHeight - $onderrand,	$imgWidth, $imgHeight,				$bgColor);
		imagefilledrectangle($im, $imgWidth-20,		0,	$imgWidth, $imgHeight,				$bgColor);

		// Tekenen van de koerswaarden links naast de grafiek
		$i=0;
		$step = $ySpan / (($imgHeight - 25 - $onderrand) / 25);
		for ($y = $imgHeight - 4 - $onderrand; $y > 15; $y -= 25){
			$label = sprintf("%.2f", $minY + $step * $i);
			imagestring($im, 1, 1, $y, $label, $textColor);
			$i++;
		}
		// Data onderaan grafiek
		$timeStamp = $begintijd;
		$step = $tijdSpan / (($imgWidth - 25 - $leftoffset) / 25);
		if ($AreDates) {
				for ($x=$leftoffset - 6; $x<=$imgWidth - 25; $x+=25){
						
					$label = strftime("%d-%m-%Y", $timeStamp);


					imagestringup($im, 1, $x+2, $imgHeight - 0, $label, $textColor);
					
					$timeStamp += $step;
		//			$timestamp = $arrY[$];
					
					if ($timeStamp > $eindtijd){
						$timeStamp = $eindtijd;
					}
				}
		} else {
			// Bottom values are not dates	
		}
		$xRes = ($imgWidth - 25 - $leftoffset) / $xSpan;
		$yRes  = ($imgHeight - 25 - $onderrand) / $ySpan;

		ImageString ($im, 2, $leftoffset, 5,  $desc, $textColor);
		ImageStringup ($im, 2, $imgWidth - imagefontheight(1) - 6, $imgHeight - $onderrand, $CRM_VERSION, $ShadowColor);

		//	Tekenen van het raster
		for ($x=$leftoffset; $x<=$imgWidth - 25; $x+=25){	// Teken verticale lijnen
			imageline($im, $x, 20, $x, $imgHeight - $onderrand, $gridColor);
		}
		for ($y=($imgHeight - $onderrand); $y>=25; $y-=25){	// Teken horizontale lijnen
			imageline($im, $leftoffset, $y, $x, $y, $gridColor);
		}
		//tekenen van omtrek
		imagerectangle($im, $leftoffset, $y, $imgWidth - 20, $imgHeight - $onderrand, $textColor);

		$labelSpacing = 25;		// + imagefontheight(1);
		$x = $leftoffset;		// Tekenen van de koersgrafiek zelf
		for ($i=0; $i<sizeof($arrY); $i++){
			$dat = strtotime($arrX[$i]);
			$dag = strftime("%a", $dat);
			// geef lijnkleur afhankelijk van dag
			
			$color = $lineColor;
			
			$val = $arrY[$i];
			$val -= $minY;
			$val *= $yRes;
			$y = $imgHeight - $val - $onderrand;

			if ($doAankoop){
				$aval = $aankoopArr[$i];
				$aval -= $minY;
				$aval *= $yRes;
				$ay = $imgHeight - $aval - $onderrand;
			}
	
			if ($x == $leftoffset){		// begin van de grafiek
				$xold = $x+10 ;
				$yold = $y+10;
				if ($doAankoop)
					$ayold = $ay;
			}
			else{
				if ($doAankoop){
					imageline($im, $xold, $ayold, $x, $ay, $purColor);	// aankoopwaarde
					imageline($im, $xold+5, $ayold+3, $x+5, $ay+3, $ShadowColor);	// Schaduw aankoop

				}
				imageline($im, $xold+5, $yold+3, $x+5, $y+3, $ShadowColor);	// Schaduw
				imageline($im, $xold+1, $yold, $x, $y, $color);	// koersgrafiek
			}
			$xold = $x;
			$yold = $y;
			if ($doAankoop){
				$ayold = $ay;
			}
			$x += $xRes;
		}

//			if ($aankoopwaarde != "")
//			{	// Teken lijn die aankoopwaarde representeert
//				$val = $aankoopwaarde;
//				$val -= $minY;
//				$val *= $yRes;
//				$y = $imgHeight - $val - $onderrand;
//				imageline($im, $leftoffset, $y, $imgWidth - 25, $y, $textColor);
//			}
		

	}	
		ImagePng ($im);
}
/*
function tekenStaafDiagram($arrX, $arrY, $desc, $imgWidth, $imgHeight)
{	$minX = getMinimum($arrX);
	$minY = getMinimum($arrY);
	$maxX = getMaximum($arrX);
	$maxY = getMaximum($arrY);
	
	$begintijd = strtotime($minX);
	$eindtijd = strtotime($maxX);
	
	$tijdSpan = $eindtijd - $begintijd;
	$xSpan = sizeof($arrX);
	$ySpan = $maxY - $minY;

	header ("Content-type: image/png");
	$im = @ImageCreate ($imgWidth, $imgHeight) or die ("Cannot Initialize new GD image stream");
	$posColor = ImageColorAllocate ($im, 0, 0, 255);		// Kleur van positieve uitslag
	$negColor = ImageColorAllocate ($im, 255, 0, 0);		// Kleur van negatieve uitslag
	$textColor = ImageColorAllocate ($im, 255, 0, 0);		// Kleur van de tekst
	$gridColor = ImageColorAllocate ($im, 200, 200, 200);	// Kleur van het raster
	$bgColor   = ImageColorAllocate ($im, 173, 184, 217);	// Achtergrondkleur

	imagefilledrectangle($im, 0, 0, $imgWidth, $imgHeight, $bgColor);	// Teken achtergrond

	if (sizeof($arrY) < 2)
	{	imagerectangle($im, 0, 0, $imgWidth - 1, $imgHeight - 1, $textColor);
		imagestring($im, 5, 10, $imgHeight/2, "Error: insufficiant information to build graph", $textColor);
	}
	else
	{	$onderrand  = imagefontwidth(1) * 11;		

		// Tekenen van de koerswaarden links naast de grafiek
		$i=0;
		$step = $ySpan / (($imgHeight - 25 - $onderrand) / 25);
		for ($y = $imgHeight - 4 - $onderrand; $y > 15; $y -= 25)
		{	$label = sprintf("%.2f", $minY + $step * $i);
			imagestring($im, 1, 1, $y, $label, $textColor);
			if (strlen($label) > $stringlengte)
				$stringlengte = strlen($label);	// Bepaal wat de langste string is
			$i++;
		}

		$leftoffset = imagefontwidth(1) * ($stringlengte + 1);

		// Data onderaan grafiek
		$timeStamp = $begintijd;
		$step = $tijdSpan / (($imgWidth - 25 - $leftoffset) / 25);
		for ($x=$leftoffset - 6; $x<=$imgWidth - 25; $x+=25)
		{	$label = strftime("%d-%m-%Y", $timeStamp);
			imagestringup($im, 1, $x, $imgHeight - 4, $label, $textColor);
			$timeStamp += $step;
			if ($timeStamp > $eindtijd)
				$timeStamp = $eindtijd;
		}

		$xRes = ($imgWidth - 25 - $leftoffset) / $xSpan;
		$yRes  = ($imgHeight - 25 - $onderrand) / $ySpan;

		ImageString ($im, 2, $leftoffset, 5,  $desc, $textColor);
//		ImageString ($im, 2, $imgWidth - 125, 5, "Koersweb.dhs.org", $gridColor);

		//	Tekenen van het raster
		for ($x=$leftoffset; $x<=$imgWidth - 25; $x+=25)	// Teken verticale lijnen
		{	imagedashedline($im, $x, 25, $x, $imgHeight - 4 - $onderrand, $gridColor);
		}
		for ($y=$imgHeight - $onderrand; $y>=25; $y-=25)	// Teken horizontale lijnen
		{	imagedashedline($im, $leftoffset, $y, $imgWidth - 25, $y, $gridColor);	// doet ut niet
				imageline($im, $leftoffset, $y, $imgWidth - 25, $y, $gridColor);		// doet ut wel
		}

		$x = $leftoffset;		// Tekenen van het diagram zelf
		for ($i=0; $i<sizeof($arrY); $i++)
		{	$val = $arrY[$i];
			$val2 = $val - $minY;
			$val2 *= $yRes;
			$y = $imgHeight - $val2 - $onderrand;
			$ybase = $imgHeight - ((0-$minY)*$yRes) - $onderrand;

			if ($x == $leftoffset)		// begin van de grafiek
			{	$xold = $x;
			}
			if ($val==abs($val))
				imagefilledrectangle($im, $xold, $y, $x, $ybase, $posColor);
			else
				imagefilledrectangle($im, $xold, $ybase, $x, $y, $negColor);
			
			$xold = $x;
			$x += $xRes;
		}
	}		
	ImagePng ($im);
}
*/
function getMinimum($arr)
{	sort($arr);
		return $arr[0];
}

function getMaximum($arr)
{	rsort($arr);
	return $arr[0];    
}


?>