<?
// ----------------------------------------------------------------------
// CUSTOMER-TOUCH CRM
// Copyright (C) 2003 by the Customer-Touch Development Team.
// http://www.customer-touch.com
// ----------------------------------------------------------------------
// Based on:
// CRM COMMERCIAL TRACKING TOOL - http://sourceforge.net/projects/crm-ctt/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html or
// take a look in the Doc directory
// ----------------------------------------------------------------------
// Original Author of this file: Alessandro Grassi
// ----------------------------------------------------------------------

session_start();
function make_field($m,$val){
	$tmp="";
	$tmp_len=(($m->max_length)/23)+1;
	settype($tmp_len,"integer");
    switch ($m->type) {
		case "blob":
			$tmp = '<textarea name="'.$m->name.'" rows="5" cols="23">'.$val.'</textarea>';
			break;
		case "int":
			$tmp = '<input type="checkbox" value="1" name="'.$m->name.'"';
			if ($val=="1") $tmp.= ' checked';
			$tmp.= '>';
			break;
		case "string":
			if ($m->max_length<31) {
				$tmp = '<input type="text" name="'.$m->name.'" size="'.$m->max_length.'"';
				if (strstr($m->name,"date") or strstr($m->name,"data")){
					if ($val=="") $tmp.=' value="'.strftime('%d-%m-%Y').'"'; 
					else $tmp.=' value="'.$val.'"'; 
				}
				else $tmp.=' value="'.$val.'"'; 
				$tmp.='>';
				if (strstr($m->name,"date") or strstr($m->name,"data")){
					$tmp.=" <a href='javascript:popcalendar2(\"".$m->name."\");' class='topnav'>[C]</a> &nbsp; &nbsp; (gg-mm-aaaa)";
				}
			}
			else $tmp = '<textarea name="'.$m->name.'" rows="'.$tmp_len.'" cols="23">'.$val.'</textarea>';
			break;
		default:
        	$tmp = '<textarea name="'.$m->name.'" rows="'.$tmp_len.'" cols="23">'.$val.'</textarea>';
	}
	return $tmp;
}

function make_text_name($m){
	if (strchr($m->name, "_")){
		$text="";
		$tmp = substr($m->name,3);
		$arr = explode("_",$tmp);
		for ($i=0; $i<sizeof($arr); $i++){
			$text.= ucfirst($arr[$i])." ";
		}
		return trim($text);
	}
	else return $m->name;
}

function get_field_type($m){
	$tmp="0";
	switch ($m->type) {
		case "blob":
			$tmp = "2"; //textarea
			break;
		case "int":
			$tmp = "0"; //checkbox
			break;
		case "string":
			$tmp = "1"; //textbox
			break;
		default:
	      	$tmp = "2"; //textarea
	}
	return $tmp;
}
?>