<?
// ----------------------------------------------------------------------
// CUSTOMER-TOUCH CRM
// Copyright (C) 2003 by the Customer-Touch Development Team.
// http://www.customer-touch.com
// ----------------------------------------------------------------------
// Based on:
// CRM COMMERCIAL TRACKING TOOL - http://sourceforge.net/projects/crm-ctt/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html or
// take a look in the Doc directory
// ----------------------------------------------------------------------
// Original Author of this file: Alessandro Grassi
// ----------------------------------------------------------------------

session_start();
$cfgfile = stripslashes($cfgfile);
if ($step=='dl') {
			header("Content-Type: text");
			header("Content-Disposition: attachment; filename=config.inc.php" );
			header("Content-Description: PHP4 Generated Data" );
			header("Window-target: _top");

			// Push attachment from variable

			print stripslashes($cfgfile);
			exit;
} elseif ($step=='write') {
	$trywrite = 1;
    if ($fp = @fopen("config.inc.php","w")) {
		$cfgfile2 = stripslashes($cfgfile);
		fputs($fp,$cfgfile2);
		fclose($fp);
        $write = "gelukt";
    } else {
        $write = "niet gelukt";
    }
	$step = 4;
}


print "<title>C R M installation procedure</title>";
?>
<META HTTP-EQUIV="Expires" CONTENT="0">
<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
</head>
<script language="JavaScript">
<!--

// Write the correct stylesheet into the document
if (navigator.appName.indexOf('Microsoft') > -1) {
	// IE stylesheet
	document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
	} else {
	// NS stylesheet (gheghe, the same :) )

	document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
}	
		//-->
</SCRIPT>

<body bgcolor="#ffffff" leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" link="#336699" text="#333333" alink="white" vlink="#666666"">
	
	<center><img src='images/ctcrm.gif'></center>
<?
if ((@filesize("config.inc.php")>0) && ($trywrite<>1)) {
    ?>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b><center>This version of CRM is already installed.</center></b><br><br><center>To run install again, delete the config.inc.php file.</center></td></tr>
		</table></center>
		</body></html>
	<?
		exit;
//	print "It seems like this version of CRM is already installed.";
}




if (!$step) {
		if (!$_REQUEST) {
				$_REQUEST = array();
				$_REQUEST = $HTTP_POST_VARS;
				$sv = "Prior to 4.1.0 (" . phpversion() . ")";
		} else {
				$sv = "> 4.1.0 (" . phpversion() . ")";
		}
		$path = realpath(".");
		$webpath = getenv("SCRIPT_NAME");
		$webhost = getenv("HOSTNAME");

		$a = (get_loaded_extensions());
		if (in_array("gd",$a)) {
				$gd = "Installed";
			} else {
				$gd = "Not installed. You will not be able to generate pictures.";
			}
	?>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b><center>Welcome to the Customer-Touch CRM installation procedure</center></b></td></tr>
		</table></center>
		<br>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2>This procedure will help you install the application by asking you a few questions. It consists of 4 steps.
		<br><br>
		This should result in a complete working copy of Customer-Touch CRM on your system.<br><br>
		In case the install procedure will fail, you can do it manally. In Doc/manual_install folder you will find what you need: a sql file, a config.inc.php and a readme file.<br><br>
		<b>Things you must know before starting:</b><br><br>
		- Your MySQL server hostname<br>
		- Your MySQL server username and password<br>
		- A non-existing database name (crmdb might be a good idea)<br>
		- Optional: the location of your company logo<br>
		- The future administrator's email adress<br>
		- Your company name (CRM main title)<br>
		- A name for the initial login account<br>
		<br><br>
		</td></tr>
		<tr><td>
		PHP version: </td><td><? echo $sv; ?></td></tr>
		<tr><td>
		PHP GD: </td><td><? echo $gd; ?></td></tr>
		<tr><td>
		Installation path: </td><td><? echo $path; ?></td></tr>
		<tr><td>
		Web host: </td><td><? echo $webhost; ?></td></tr>
		<tr><td>
		Web path: </td><td><? echo dirname($webpath) . "/"; ?></td></tr>
		</td></tr>
		<tr><td colspan=2><b>If above information is not correct, you'll have to copy all files to the right host/directory.</td></tr>
		
		<form name='inst' action='install.php' method='POST'>

		<tr><td colspan=2><b>Check this box [ <input type=checkbox name=upgrade value='1'> ] of you are upgrading from a previous version.</td></tr>

	
		</table></center>
		<center>
		<br>
		
		<input type='hidden' name='step' value='1'>
		<input type='submit' name='knop' value='Go to step 1'>
		</form>
		</center>
		</body>
		</html>

	<?
} elseif ($step==1) {
	printstepheader("1");
		?>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b>Please provide the following information:</b>
		</td></tr>
		<tr><td><form name='sql' action='install.php' method='POST'>
		MySQL host: </td><td><input type='text' name='sqlhost' size='30'></td></tr>
		<tr><td>
		MySQL username: </td><td><input type='text' name='sqluser' size='30'></td></tr>
		<tr><td>
		MySQL password: </td><td><input type='password' name='sqlpwd' size='30'></td></tr>
		<tr><td>
	<?
		if ($upgrade) {
			print "Mysql database:<br><i>(the existing database)</i></td><td><input type='text' name='sqldb' size='30'></td></tr>";
			print "<input type='hidden' name='upgrade' value='1'>";
		} else {
			print "Mysql database:<br><i>(This database will be created)</i></td><td><input type='text' name='sqldb' size='30'></td></tr>";
		}
			?>
		
		</td></tr>
		</table></center>
		<center>
		<br>
		<input type='hidden' name='step' value='2'>
		<input type='submit' name='knop' value='Go to step 2'>
		</form>
		</center>
		</body>
		</html>
	<?

} elseif ($step==2) {
    printstepheader("2");
	if ((!$sqlhost) || (!$sqluser) || (!$sqldb)) {
		printerror("");
	}

	testsql($sqlhost,$sqluser,$sqlpwd);
	?>
	<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
	<tr><td colspan=2>Database information was OK, the connection has been tested.<br><br></td></tr></table><br>
	<?

	if (!$upgrade) {

			if (mysql_create_db($sqldb)) {
				
			} else {
				print "<input type=hidden name=bla value=\"";
				printerror("Could not create the database. <br><br>The reported error is: " . mysql_error () . "<br><br>Please Press 'back' in your browser and try again.");

			}
				?>
			<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
			<tr><td colspan=2>Database <? echo $sqldb;?> was created succesfully.<br><br></td></tr></table><br>
		<?
			
			
			$db = mysql_connect($sqlhost, $sqluser, $sqlpwd);
			mysql_select_db($sqldb,$db);

			$sqla = array();
			$sqla = fillarray();
			print "<input type=hidden name=bla value=\"";
				
				for ($x=0;$x<sizeof($sqla);$x++) {
					$result= mysql_query($sqla[$x]) or printerror("An error occured while importing the database structure!<br><br>The reported error is: " . mysql_error () . "<br><br>Please Press 'back' in your browser and try again.");
				}

			
			print "\">";
			?>
			<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
			<tr><td colspan=2>Database structure was successfully imported.<br><br></td></tr></table>
<?
			} else {
			$db = mysql_connect($sqlhost, $sqluser, $sqlpwd);
			mysql_select_db($sqldb,$db);
			print "<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
			print "<tr><td>Database available.</td></tr></table>";
			}
?>
			<center><br>	
		<form name='inst' action='install.php' method='POST'>
		<input type='hidden' name='step' value='3'>
		<input type='hidden' name='upgrade' value='<? echo $upgrade;?>'>
		<input type='submit' name='knop' value='Go to step 3'>
		<?
		print "<input type='hidden' name='sqldb' value='$sqldb'>";
		print "<input type='hidden' name='sqluser' value='$sqluser'>";
		print "<input type='hidden' name='sqlpwd' value='$sqlpwd'>";
		print "<input type='hidden' name='sqlhost' value='$sqlhost'>";

		?>
		</form>
    	</center>
	</body>
	</html>
	<?
} elseif ($step==3) {
    printstepheader("3");
	if (!$upgrade) {
	?>
	<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b>Please provide the following information:</b>
		</td></tr>
		<tr><td><form name='addinfo' action='install.php' method='POST'>
		Company name: </td><td><input type='text' name='cname' size='30' value='My Demo Company'></td></tr>
		<tr><td>
		Your company logo location: </td><td><input type='text' name='logo' size='30' value='images/ctcrm.gif'></td></tr>
		<tr><td>
		Administrator's email: </td><td><input type='text' name='admemail' size='30' value=''></td></tr>
		<tr><td>
		Initial login account name: </td><td><input type='text' name='fstaccount' size='30' value=''></td></tr>
		<tr><td>
		Initial login account password: </td><td><input type='password' name='fstpwd1' size='30' value=''></td></tr>
		<tr><td>
		Again: </td><td><input type='password' name='fstpwd2' size='30' value=''></td></tr>
		</td></tr>
		
		<?
	} else {
			?>
				<form name='addinfo' action='install.php' method='POST'>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b>Everything seems ok.</b>
		</td></tr>

		<?
		}
		?>
			</table></center>
		<center>
		<br>
		<input type='hidden' name='step' value='4'>
			<?
		print "<input type='hidden' name='sqldb' value='$sqldb'>";
		print "<input type='hidden' name='upgrade' value='$upgrade'>";
		print "<input type='hidden' name='sqluser' value='$sqluser'>";
		print "<input type='hidden' name='sqlpwd' value='$sqlpwd'>";
		print "<input type='hidden' name='sqlhost' value='$sqlhost'>";
		?>
		<input type='submit' name='knop' value='Go to step 4'>
		</form>
		</center>
		</body>
		</html>
	<?
} elseif ($step==4) {
		
		if ((!$trywrite) && (!$upgrade)) {
		    

			if ((!$cname) || (!$admemail) || (!$fstaccount) || (!$fstpwd1) || (!$fstpwd2)) {
					printerror("");
			}
			if ($fstpwd1<>$fstpwd2) {
					printerror("Passwords do not match. Press 'back' in your browser and try again.");
			}
			if ($fstpwd1=="") {
					printerror("Sorry, password cannot be empty. Press 'back' in your browser and try again.");
			}

			if ($logo=="") {
				$logo="*NONE*";
			}
		   $db = mysql_connect($sqlhost, $sqluser, $sqlpwd);
			mysql_select_db($sqldb,$db);
			$sqla = array();
			$sqla = datafill($fstaccount,$fstpwd1,$admemail,$cname,$logo);
			
			for ($x=0;$x<sizeof($sqla);$x++) {
				$result= mysql_query($sqla[$x]) or die (printerror("An error occured while importing settings!<br><br>The reported error is: " . mysql_error () . "<br><br>Please Press 'back' in your browser and try again."));
			}
			

				$cfgfile .= '<?';
				$cfgfile .= "\n";
				$cfgfile .= '$host = "'. $sqlhost . '";';    
				$cfgfile .= "\n";
				$cfgfile .= '$user= "'. $sqluser . '";';                                        // SQL-user
				$cfgfile .= "\n";
				$cfgfile .= '$pass= "'. $sqlpwd . '";';                                          // SQL-pass
				$cfgfile .= "\n";
				$cfgfile .= '$database= "' . $sqldb .'";';                                // CRM-database
				$cfgfile .= "\n";
				$cfgfile .= '$db = mysql_connect($host, $user, $pass);';
				$cfgfile .= "\n";
				$cfgfile .= 'mysql_select_db($database,$db);';
				$cfgfile .= "\n";
				$cfgfile .= 'include("includes/getset.php");';
				$cfgfile .= "\n";
				$cfgfile .= '?>';

		} // end if !trywrite
	
	?>
			<?
		
		if ($upgrade) {
				$cfgfile .= '<?';
				$cfgfile .= "\n";
				$cfgfile .= '$host = "'. $sqlhost . '";';    
				$cfgfile .= "\n";
				$cfgfile .= '$user= "'. $sqluser . '";';                                        // SQL-user
				$cfgfile .= "\n";
				$cfgfile .= '$pass= "'. $sqlpwd . '";';                                          // SQL-pass
				$cfgfile .= "\n";
				$cfgfile .= '$database= "' . $sqldb .'";';                                // CRM-database
				$cfgfile .= "\n";
				$cfgfile .= '$db = mysql_connect($host, $user, $pass);';
				$cfgfile .= "\n";
				$cfgfile .= 'mysql_select_db($database,$db);';
				$cfgfile .= "\n";
				$cfgfile .= 'include("includes/getset.php");';
				$cfgfile .= "\n";
				$cfgfile .= '?>';
		}
?><?
		if ($write=="niet gelukt") {
				$b = get_perms("config.inc.php");
				?>
					<SCRIPT LANGUAGE="JavaScript">
					<!--
					alert("Writing failed. The permissions are <? echo $b;?> which is not enough!");
					//-->
					</SCRIPT>
				<?
		} elseif ($write=="gelukt") {
				$b = get_perms("config.inc.php");
   				?>
					<SCRIPT LANGUAGE="JavaScript">
					<!--
					alert("Writing succesfull! The permissions of config.inc.php now are <? echo $b;?>. Change it back to at least 755!");
					//-->
					</SCRIPT>
				<?
		}

		?>
		
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b>All is set. The only thing left is to create the config file.</b>
		<br><br>
			This can be done in three ways:<br><br>
			1. Let the install procedure try to write the file itself <br>
			<i>You must chmod 777 the file temporary to let this work!</i><br>
			2. Download the file to you browser and place it in the installation directory yourself<br>
			3. Copy the below printed text into the config.inc.php file yourself<br>
		</td></tr>
		<tr><td>
			Click this link to let the installer try to write the config.inc.php file.
			<? echo $a;?>
			<form name='dlcfg' action='install.php' method='POST'>
			<input type='hidden' name='step' value='write'>
			<input type='hidden' name='cfgfile' value='<? echo $cfgfile; ?>'>
			<input type='submit' name='knop' value='Try now'>
			</form>	

		</td></tr>
		<tr><td>
			Click this link to download the config.inc.php file.
			<form name='dlcfg' action='install.php' method='POST'>
			<input type='hidden' name='step' value='dl'>
			<input type='hidden' name='cfgfile' value='<? echo $cfgfile; ?>'>
			<input type='submit' name='knop' value='Dowload config.inc.php file'>
			</form>
		</td></tr>

		<tr><td><br>If that doesn't work, create a file called config.inc.php in your installation directory containing the following:
		<br>
		<br>
		<?
		print "<pre>";
		print htmlspecialchars($cfgfile);
		print "</pre>";
		?>
		<br>
			</td></tr>
		<tr><td>When done, point your browser <a href='index.php' class='topnav'>here</a>.</td></tr>

		</table>
			</body>
			</html>
	<?
	
} 






function testsql($host,$user,$pass)
{
	print "<input type=hidden name=bla value=\"";
    $link = mysql_pconnect($host, $user, $pass)
     or printerror("Could not connect to your database system. <br><br>The reported error is: " . mysql_error () . "<br><br>Please Press 'back' in your browser and try again.");
	print "\">";
} // end func


function printerror($a)
{
		if (stristr($a,"reported error")) {
		    	print "\">";
		}
		if (!$a) {
		    $a="You didn't provide all required information. Press 'back' in your browser and try again.";
		}
		?>
		<center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b><? echo $a;?></b>
		</td></tr></table></body></html>
		<?
			exit;
} // end func



function printstepheader($step)
{
	?>
			
	    <center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><b><center>CRM installation procedure - step <? echo $step;?></center></b></td></tr>
		</table></center>
		<br>
	<?
} // end func






function fillarray()
{
	// This function fills the sqla array with queries to create the CRM database table structure

	$sqla[0] = "CREATE TABLE CRMaction (
  ac_id int(11) NOT NULL auto_increment,
  ac_e_id int(11) NOT NULL default '0',
  ac_type_id tinyint(2) NOT NULL default '0',
  ac_setdate date NOT NULL default '0000-00-00',
  ac_operator int(11) default '0',
  ac_info text,
  ac_date date NOT NULL default '0000-00-00',
  ac_done tinyint(1) NOT NULL default '0',
  ac_done_date date default NULL,
  PRIMARY KEY  (ac_id)
) TYPE=MyISAM";
	
	$sqla[1] = "CREATE TABLE CRMactiontype (
  at_id tinyint(2) NOT NULL auto_increment,
  at_name varchar(255) NOT NULL default '',
  PRIMARY KEY  (at_id),
  UNIQUE KEY at_name (at_name)
) TYPE=MyISAM COMMENT='Action Types '";

	$sqla[2] = "CREATE TABLE CRMaddress (
  a_id int(11) NOT NULL auto_increment,
  a_c_id int(11) NOT NULL default '0',
  a_name text NOT NULL,
  PRIMARY KEY  (a_id)
) TYPE=MyISAM";

	$sqla[3] = "CREATE TABLE CRMbinfiles (
  fileid bigint(20) NOT NULL auto_increment,
  koppelid bigint(20) NOT NULL default '0',
  content mediumblob NOT NULL,
  filename varchar(200) NOT NULL default '',
  creation_date timestamp(14) NOT NULL,
  filesize mediumint(9) NOT NULL default '0',
  filetype varchar(150) NOT NULL default '',
  PRIMARY KEY  (fileid),
  KEY fileid (fileid)
) TYPE=MyISAM COMMENT='Binaire files stand-alone tabel'";

	$sqla[4] = "CREATE TABLE CRMcalendar (
  user varchar(20) NOT NULL default '',
  Tijdpostzegel timestamp(14) NOT NULL,
  datum date NOT NULL default '0000-00-00',
  basicdate varchar(8) NOT NULL default '',
  calendarid mediumint(5) NOT NULL auto_increment,
  type varchar(10) NOT NULL default '',
  customnum varchar(12) NOT NULL default '',
  emailadress varchar(150) NOT NULL default '',
  eID varchar(5) NOT NULL default '',
  PRIMARY KEY  (calendarid),
  KEY Tijdpostzegel (Tijdpostzegel)
) TYPE=MyISAM";

	$sqla[5] = "CREATE TABLE CRMcustomer (
  cr_id int(11) NOT NULL auto_increment,
  cr_fastname varchar(255) NOT NULL default '',
  cr_indirizzo text,
  cr_codice_cliente varchar(255) default NULL,
  cr_proprietario text,
  cr_ragione_sociale_cliente text,
  cr_cap varchar(255) default NULL,
  cr_citt varchar(255) default NULL,
  cr_provincia varchar(255) default NULL,
  cr_partita_iva varchar(255) default NULL,
  cr_telefono varchar(255) default NULL,
  cr_gsm varchar(30) default NULL,
  cr_fax varchar(30) default NULL,
  cr_email varchar(30) default NULL,
  cr_note text,
  cr_newsletter tinyint(1) default '0',
  PRIMARY KEY  (cr_id),
  UNIQUE KEY id (cr_id),
  KEY id_2 (cr_id)
) TYPE=MyISAM";

	$sqla[6] = "CREATE TABLE CRMcustomerlink (
  cl_id_cust int(11) NOT NULL default '0',
  cl_id_user int(11) NOT NULL default '0',
  PRIMARY KEY  (cl_id_cust,cl_id_user)
) TYPE=MyISAM COMMENT='Agente table'";



	$sqla[7] = "CREATE TABLE CRMentity (
  eid int(11) NOT NULL auto_increment,
  ecounter int(11) NOT NULL default '0',
  eyear int(5) NOT NULL default '0',
  category varchar(150) NOT NULL default '',
  comment longtext NOT NULL,
  content longtext NOT NULL,
  status enum('1','2','3','5','21','22','4') NOT NULL default '1',
  priority enum('1','2','3','4') NOT NULL default '1',
  owner int(11) NOT NULL default '0',
  assignee int(11) NOT NULL default '0',
  CRMcustomer int(11) NOT NULL default '0',
  tp timestamp(14) NOT NULL,
  deleted enum('n','y') NOT NULL default 'n',
  duedate varchar(15) NOT NULL default '',
  sqldate date NOT NULL default '0000-00-00',
  obsolete enum('y','n') NOT NULL default 'n',
  cdate date NOT NULL default '0000-00-00',
  waiting enum('n','y') NOT NULL default 'n',
  closedate date NOT NULL default '0000-00-00',
  errorid tinyint(2) default NULL,
  product_id int(5) default NULL,
  trasportatore int(11) default NULL,
  ealarm tinytext,
  eaddress int(11) default NULL,
  en_numero_ordine_cliente varchar(255) default NULL,
  en_numero_lista_di_prelievo varchar(255) default NULL,
  en_data_lista_di_prelievo varchar(255) default NULL,
  en_numero_ddt varchar(255) default NULL,
  en_data_ddt varchar(255) default NULL,
  en_numero_fattura varchar(255) default NULL,
  en_data_fattura varchar(255) default NULL,
  en_numero_totale_colli varchar(255) default NULL,
  en_codice_id_colli varchar(255) default NULL,
  en_codici_e_quantit_prodotti_coinvolti text,
  en_contatto_co_trasport text,
  en_analisi_e_soluzione_possibile text,
  en_comment varchar(255) NOT NULL default '',
  PRIMARY KEY  (eid),
  UNIQUE KEY id (eid),
  KEY id_2 (eid)
) TYPE=MyISAM";


	$sqla[8] = "CREATE TABLE CRMentityproduct (
  ep_eid int(11) NOT NULL default '0',
  ep_pr_id int(5) NOT NULL default '0',
  ep_sign enum('+','-') NOT NULL default '+',
  ep_qnt varchar(10) NOT NULL default ''
) TYPE=MyISAM";



	$sqla[9] = "CREATE TABLE CRMerror (
  er_id tinyint(2) NOT NULL auto_increment,
  er_name varchar(100) NOT NULL default '',
  PRIMARY KEY  (er_id)
) TYPE=MyISAM COMMENT='WHO MADE THE ERROR? '";

$sqla[10] = "CREATE TABLE CRMhelp (
  helpid bigint(20) NOT NULL auto_increment,
  title varchar(240) NOT NULL default '',
  content longtext NOT NULL,
  PRIMARY KEY  (helpid)
) TYPE=MyISAM COMMENT='Help table voor CRM'";

$sqla[11] = "CREATE TABLE CRMmodule (
  mo_id tinyint(3) NOT NULL auto_increment,
  mo_name varchar(255) NOT NULL default '',
  mo_descr text,
  mo_mg_id tinyint(3) NOT NULL default '0',
  mo_file varchar(255) default NULL,
  mo_icon varchar(255) default NULL,
  mo_order tinyint(3) default NULL,
  mo_menu tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (mo_id)
) TYPE=MyISAM";

$sqla[12] = "CREATE TABLE CRMmodulegroup (
  mg_id tinyint(3) NOT NULL auto_increment,
  mg_name varchar(255) NOT NULL default '',
  mg_icon varchar(255) default NULL,
  mg_order tinyint(3) default NULL,
  PRIMARY KEY  (mg_id)
) TYPE=MyISAM COMMENT='Classifaing of modules'";


$sqla[13] = "CREATE TABLE CRMorg_main (
  om_id int(14) NOT NULL auto_increment,
  om_name varchar(255) NOT NULL default '',
  om_note text,
  om_type_id tinyint(4) NOT NULL default '0',
  om_status enum('','done','cancel') NOT NULL default '',
  om_time datetime NOT NULL default '0000-00-00 00:00:00',
  om_alarm_time datetime default NULL,
  om_us_id int(14) NOT NULL default '0',
  om_fus_id int(14) default NULL,
  PRIMARY KEY  (om_id)
) TYPE=MyISAM";


$sqla[14] = "CREATE TABLE CRMorg_type (
  ot_id tinyint(4) NOT NULL auto_increment,
  ot_name varchar(255) NOT NULL default '',
  ot_icon varchar(255) default NULL,
  PRIMARY KEY  (ot_id)
) TYPE=MyISAM";



$sqla[15] = "CREATE TABLE CRMproduct (
  pr_id int(5) NOT NULL auto_increment,
  pr_name varchar(255) NOT NULL default '',
  pr_descr varchar(255) NOT NULL default '',
  pr_img varchar(255) NOT NULL default '',
  PRIMARY KEY  (pr_id)
) TYPE=MyISAM";

$sqla[16] = "CREATE TABLE CRMrole (
  ro_id tinyint(4) NOT NULL auto_increment,
  ro_name varchar(255) NOT NULL default '',
  ro_descr text,
  PRIMARY KEY  (ro_id)
) TYPE=MyISAM";

$sqla[17] = "CREATE TABLE CRMrolelink (
  rl_ro_id tinyint(3) NOT NULL default '0',
  rl_mo_id tinyint(4) NOT NULL default '0',
  rl_date date NOT NULL default '0000-00-00'
) TYPE=MyISAM";

$sqla[18] = "CREATE TABLE CRMsessions (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  temp varchar(100) NOT NULL default '',
  active enum('yes','no') NOT NULL default 'yes',
  exptime varchar(40) NOT NULL default '',
  noexp enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
) TYPE=MyISAM";

$sqla[19] = "CREATE TABLE CRMsettings (
  settingid bigint(20) NOT NULL auto_increment,
  setting varchar(150) NOT NULL default '',
  value varchar(250) NOT NULL default '',
  datetime timestamp(14) NOT NULL,
  discription varchar(250) NOT NULL default '',
  UNIQUE KEY settingid (settingid)
) TYPE=MyISAM COMMENT='Settings for CRM'";

$sqla[20] = "CREATE TABLE CRMuselog (
  id bigint(20) NOT NULL auto_increment,
  ip varchar(15) NOT NULL default '',
  url varchar(50) NOT NULL default '',
  useragent varchar(255) NOT NULL default '',
  tijd timestamp(14) NOT NULL,
  qs varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY tijd (tijd),
  KEY url (url),
  KEY tijd_2 (tijd),
  KEY ip (ip)
) TYPE=MyISAM";

$sqla[21] = "CREATE TABLE CRMusers (
  us_id int(11) NOT NULL auto_increment,
  us_name varchar(50) NOT NULL default '',
  us_password varchar(40) default NULL,
  us_type tinyint(4) NOT NULL default '0',
  us_active tinyint(1) NOT NULL default '0',
  us_exptime varchar(40) default NULL,
  ys_noexp tinyint(1) NOT NULL default '0',
  us_brmember tinyint(1) default '0',
  us_unused tinyint(1) default '0',
  us_email varchar(150) NOT NULL default '',
  us_language varchar(15) NOT NULL default 'english',
  us_real_name varchar(255) default NULL,
  us_codice_id varchar(255) default NULL,
  us_dipartimento varchar(255) default NULL,
  us_telefono varchar(255) default NULL,
  us_fax varchar(255) default NULL,
  us_indirizzo text,
  PRIMARY KEY  (us_id),
  UNIQUE KEY id (us_id),
  KEY id_2 (us_id)
) TYPE=MyISAM";



	return($sqla);

} // end func



function datafill($fstaccount,$fstpwd1,$admemail,$cname,$logo)

{
$sqla[ 0 ] = " INSERT INTO CRMactiontype VALUES (1, 'Phone call')"; 
$sqla[ 1 ] = " INSERT INTO CRMactiontype VALUES (2, 'Email')"; 
$sqla[ 2 ] = " INSERT INTO CRMactiontype VALUES (7, 'Fax: trasporter, pickup and deliver to another customer')"; 
$sqla[ 3 ] = " INSERT INTO CRMactiontype VALUES (4, 'Fax: customer, prepare pro-forma invoice')"; 
$sqla[ 4 ] = " INSERT INTO CRMactiontype VALUES (5, 'Fax: customer, prepare items for reshipment')"; 
$sqla[ 5 ] = " INSERT INTO CRMactiontype VALUES (6, 'Fax: trasporter, pickup and ship to our logistic unit')"; 
$sqla[ 6 ] = " INSERT INTO CRMactiontype VALUES (3, 'Fax')"; 


$sqla[ 7 ] = " INSERT INTO CRMerror VALUES (1, 'Our Logistic')"; 
$sqla[ 8 ] = " INSERT INTO CRMerror VALUES (2, 'The client')"; 
$sqla[ 9 ] = " INSERT INTO CRMerror VALUES (3, 'The Sale Agent')"; 
$sqla[ 10 ] = " INSERT INTO CRMerror VALUES (4, 'Sales Dept.')"; 
$sqla[ 11 ] = " INSERT INTO CRMerror VALUES (6, 'The Forwarder')"; 
$sqla[ 12 ] = " INSERT INTO CRMerror VALUES (7, 'The product/production')"; 
$sqla[ 13 ] = " INSERT INTO CRMerror VALUES (8, 'Unknown')"; 



$sqla[ 14 ] = " INSERT INTO CRMmodule VALUES (1, '1', '1', 1, 'edit.php?e=_new_&key=0', 'icon1.gif', 8, 0)"; 
$sqla[ 15 ] = " INSERT INTO CRMmodule VALUES (9, '12', '12', 2, 'admin.php?key=1', 'icon10.gif', 47, 0)"; 
$sqla[ 16 ] = " INSERT INTO CRMmodule VALUES (5, '7', '7', 2, 'csv.php?key=1', 'icon5.gif', 24, 0)"; 
$sqla[ 17 ] = " INSERT INTO CRMmodule VALUES (4, '8', '8', 2, 'customers.php?key=1', 'icon4.gif', 28, 0)"; 
$sqla[ 18 ] = " INSERT INTO CRMmodule VALUES (3, '4', '4', 1, 'del.php?key=0', 'icon3.gif', 27, 0)"; 
$sqla[ 19 ] = " INSERT INTO CRMmodule VALUES (11, '14', '14', 2, 'javascript:pophelp(13);', 'icon12.gif', 64, 0)"; 
$sqla[ 20 ] = " INSERT INTO CRMmodule VALUES (2, '2', '2', 1, 'entry.php?ShowEntitiesOpen=1&key=0', 'icon2.gif', 14, 0)"; 
$sqla[ 21 ] = " INSERT INTO CRMmodule VALUES (10, '13', '13', 2, 'javascript:pophelp(contents);', 'icon11.gif', 53, 0)"; 
$sqla[ 22 ] = " INSERT INTO CRMmodule VALUES (7, '9', '9', 2, 'stats.php?key=1', 'icon8.gif', 32, 0)"; 
$sqla[ 23 ] = " INSERT INTO CRMmodule VALUES (8, '10', '10', 2, 'grph.php?key=1', 'icon9.gif', 37, 0)"; 
$sqla[ 24 ] = " INSERT INTO CRMmodule VALUES (6, '3', '3', 1, 'summary.php?key=0', 'icon6.gif', 18, 0)"; 
$sqla[ 25 ] = " INSERT INTO CRMmodule VALUES (111, '15', '15', 1, 'index.php?logout=1', 'icon7.gif', 72, 0)"; 
$sqla[ 26 ] = " INSERT INTO CRMmodule VALUES (12, '5', '5', 1, 'editclose.php?key=0', 'sem.gif', 33, 0)"; 
$sqla[ 27 ] = " INSERT INTO CRMmodule VALUES (13, '6', '6', 1, 'entityclose.php?key=0', 'sem.gif', 51, 0)"; 
$sqla[ 28 ] = " INSERT INTO CRMmodule VALUES (112, '11', '11', 2, 'products.php', 'products.gif', 41, 0)"; 
$sqla[ 29 ] = " INSERT INTO CRMmodule VALUES (127, '17', '17', 1, 'calorg.php', 'calendar.gif', 28, 0)"; 


$sqla[ 30 ] = " INSERT INTO CRMmodulegroup VALUES (1, 'T1', 'icon_open.gif', 1)"; 
$sqla[ 31 ] = " INSERT INTO CRMmodulegroup VALUES (2, 'T2', 'icon_tool.gif', 2)";

 
$sqla[ 32 ] = " INSERT INTO CRMrole VALUES (1, 'Administrator', 'Full access for admin purposes')"; 
$sqla[ 33 ] = " INSERT INTO CRMrole VALUES (2, 'Validator 1', 'Close entity in awaiting closure')"; 
$sqla[ 34 ] = " INSERT INTO CRMrole VALUES (3, 'CRM Desk User', 'An ordinary desk user without admin and validation permissions')"; 
$sqla[ 35 ] = " INSERT INTO CRMrole VALUES (4, 'Sell man', 'sell man')"; 
$sqla[ 36 ] = " INSERT INTO CRMrole VALUES (5, 'Validator 2', 'Close entity in awaiting closure')"; 
$sqla[ 37 ] = " INSERT INTO CRMrole VALUES (6, 'Transporter', 'An external transport company')"; 


$sqla[ 38 ] = " INSERT INTO CRMrolelink VALUES (0, 11, '0000-00-00')"; 
$sqla[ 39 ] = " INSERT INTO CRMrolelink VALUES (0, 10, '0000-00-00')"; 
$sqla[ 40 ] = " INSERT INTO CRMrolelink VALUES (0, 9, '0000-00-00')"; 
$sqla[ 41 ] = " INSERT INTO CRMrolelink VALUES (0, 8, '0000-00-00')"; 
$sqla[ 42 ] = " INSERT INTO CRMrolelink VALUES (0, 7, '0000-00-00')"; 
$sqla[ 43 ] = " INSERT INTO CRMrolelink VALUES (0, 0, '0000-00-00')"; 
$sqla[ 44 ] = " INSERT INTO CRMrolelink VALUES (1, 10, '0000-00-00')"; 
$sqla[ 45 ] = " INSERT INTO CRMrolelink VALUES (1, 9, '0000-00-00')"; 
$sqla[ 46 ] = " INSERT INTO CRMrolelink VALUES (1, 112, '0000-00-00')"; 
$sqla[ 47 ] = " INSERT INTO CRMrolelink VALUES (1, 8, '0000-00-00')"; 
$sqla[ 48 ] = " INSERT INTO CRMrolelink VALUES (1, 7, '0000-00-00')"; 
$sqla[ 49 ] = " INSERT INTO CRMrolelink VALUES (1, 4, '0000-00-00')"; 
$sqla[ 50 ] = " INSERT INTO CRMrolelink VALUES (0, 6, '0000-00-00')"; 
$sqla[ 51 ] = " INSERT INTO CRMrolelink VALUES (0, 5, '0000-00-00')"; 
$sqla[ 52 ] = " INSERT INTO CRMrolelink VALUES (1, 5, '0000-00-00')"; 
$sqla[ 53 ] = " INSERT INTO CRMrolelink VALUES (2, 7, '0000-00-00')"; 
$sqla[ 54 ] = " INSERT INTO CRMrolelink VALUES (0, 4, '0000-00-00')"; 
$sqla[ 55 ] = " INSERT INTO CRMrolelink VALUES (0, 3, '0000-00-00')"; 
$sqla[ 56 ] = " INSERT INTO CRMrolelink VALUES (0, 13, '0000-00-00')"; 
$sqla[ 57 ] = " INSERT INTO CRMrolelink VALUES (0, 12, '0000-00-00')"; 
$sqla[ 58 ] = " INSERT INTO CRMrolelink VALUES (0, 2, '0000-00-00')"; 
$sqla[ 59 ] = " INSERT INTO CRMrolelink VALUES (3, 11, '0000-00-00')"; 
$sqla[ 60 ] = " INSERT INTO CRMrolelink VALUES (3, 10, '0000-00-00')"; 
$sqla[ 61 ] = " INSERT INTO CRMrolelink VALUES (3, 112, '0000-00-00')"; 
$sqla[ 62 ] = " INSERT INTO CRMrolelink VALUES (3, 4, '0000-00-00')"; 
$sqla[ 63 ] = " INSERT INTO CRMrolelink VALUES (3, 111, '0000-00-00')"; 
$sqla[ 64 ] = " INSERT INTO CRMrolelink VALUES (3, 3, '0000-00-00')"; 
$sqla[ 65 ] = " INSERT INTO CRMrolelink VALUES (3, 6, '0000-00-00')"; 
$sqla[ 66 ] = " INSERT INTO CRMrolelink VALUES (3, 2, '0000-00-00')"; 
$sqla[ 67 ] = " INSERT INTO CRMrolelink VALUES (4, 11, '0000-00-00')"; 
$sqla[ 68 ] = " INSERT INTO CRMrolelink VALUES (4, 10, '0000-00-00')"; 
$sqla[ 69 ] = " INSERT INTO CRMrolelink VALUES (4, 4, '0000-00-00')"; 
$sqla[ 70 ] = " INSERT INTO CRMrolelink VALUES (4, 6, '0000-00-00')"; 
$sqla[ 71 ] = " INSERT INTO CRMrolelink VALUES (4, 2, '0000-00-00')"; 
$sqla[ 72 ] = " INSERT INTO CRMrolelink VALUES (4, 1, '0000-00-00')"; 
$sqla[ 73 ] = " INSERT INTO CRMrolelink VALUES (2, 4, '0000-00-00')"; 
$sqla[ 74 ] = " INSERT INTO CRMrolelink VALUES (127, 11, '0000-00-00')"; 
$sqla[ 75 ] = " INSERT INTO CRMrolelink VALUES (127, 10, '0000-00-00')"; 
$sqla[ 76 ] = " INSERT INTO CRMrolelink VALUES (127, 7, '0000-00-00')"; 
$sqla[ 77 ] = " INSERT INTO CRMrolelink VALUES (127, 0, '0000-00-00')"; 
$sqla[ 78 ] = " INSERT INTO CRMrolelink VALUES (127, 12, '0000-00-00')"; 
$sqla[ 79 ] = " INSERT INTO CRMrolelink VALUES (127, 3, '0000-00-00')"; 
$sqla[ 80 ] = " INSERT INTO CRMrolelink VALUES (127, 6, '0000-00-00')"; 
$sqla[ 81 ] = " INSERT INTO CRMrolelink VALUES (0, 1, '0000-00-00')"; 
$sqla[ 82 ] = " INSERT INTO CRMrolelink VALUES (127, 2, '0000-00-00')"; 
$sqla[ 83 ] = " INSERT INTO CRMrolelink VALUES (2, 5, '0000-00-00')"; 
$sqla[ 84 ] = " INSERT INTO CRMrolelink VALUES (2, 111, '0000-00-00')"; 
$sqla[ 85 ] = " INSERT INTO CRMrolelink VALUES (2, 13, '0000-00-00')"; 
$sqla[ 86 ] = " INSERT INTO CRMrolelink VALUES (2, 3, '0000-00-00')"; 
$sqla[ 87 ] = " INSERT INTO CRMrolelink VALUES (2, 6, '0000-00-00')"; 
$sqla[ 88 ] = " INSERT INTO CRMrolelink VALUES (2, 2, '0000-00-00')"; 
$sqla[ 89 ] = " INSERT INTO CRMrolelink VALUES (1, 127, '0000-00-00')"; 
$sqla[ 90 ] = " INSERT INTO CRMrolelink VALUES (1, 111, '0000-00-00')"; 
$sqla[ 91 ] = " INSERT INTO CRMrolelink VALUES (1, 13, '0000-00-00')"; 
$sqla[ 92 ] = " INSERT INTO CRMrolelink VALUES (1, 12, '0000-00-00')"; 
$sqla[ 93 ] = " INSERT INTO CRMrolelink VALUES (1, 3, '0000-00-00')"; 
$sqla[ 94 ] = " INSERT INTO CRMrolelink VALUES (1, 6, '0000-00-00')"; 
$sqla[ 95 ] = " INSERT INTO CRMrolelink VALUES (1, 2, '0000-00-00')"; 
$sqla[ 96 ] = " INSERT INTO CRMrolelink VALUES (3, 1, '0000-00-00')"; 
$sqla[ 97 ] = " INSERT INTO CRMrolelink VALUES (1, 1, '0000-00-00')"; 
$sqla[ 98 ] = " INSERT INTO CRMrolelink VALUES (5, 2, '0000-00-00')"; 
$sqla[ 99 ] = " INSERT INTO CRMrolelink VALUES (5, 6, '0000-00-00')"; 
$sqla[ 100 ] = " INSERT INTO CRMrolelink VALUES (5, 3, '0000-00-00')"; 
$sqla[ 101 ] = " INSERT INTO CRMrolelink VALUES (5, 12, '0000-00-00')"; 
$sqla[ 102 ] = " INSERT INTO CRMrolelink VALUES (5, 111, '0000-00-00')"; 
$sqla[ 103 ] = " INSERT INTO CRMrolelink VALUES (5, 5, '0000-00-00')"; 
$sqla[ 104 ] = " INSERT INTO CRMrolelink VALUES (5, 4, '0000-00-00')"; 
$sqla[ 105 ] = " INSERT INTO CRMrolelink VALUES (5, 7, '0000-00-00')"; 
$sqla[ 106 ] = " INSERT INTO CRMrolelink VALUES (5, 8, '0000-00-00')"; 
$sqla[ 107 ] = " INSERT INTO CRMrolelink VALUES (5, 112, '0000-00-00')"; 
$sqla[ 108 ] = " INSERT INTO CRMrolelink VALUES (5, 10, '0000-00-00')"; 
$sqla[ 109 ] = " INSERT INTO CRMrolelink VALUES (5, 11, '0000-00-00')"; 
$sqla[ 110 ] = " INSERT INTO CRMrolelink VALUES (2, 8, '0000-00-00')"; 
$sqla[ 111 ] = " INSERT INTO CRMrolelink VALUES (2, 112, '0000-00-00')"; 
$sqla[ 112 ] = " INSERT INTO CRMrolelink VALUES (2, 10, '0000-00-00')"; 
$sqla[ 113 ] = " INSERT INTO CRMrolelink VALUES (2, 11, '0000-00-00')"; 
$sqla[ 114 ] = " INSERT INTO CRMrolelink VALUES (1, 11, '0000-00-00')"; 


$sqla[ 115 ] = " INSERT INTO CRMsettings VALUES (1, 'title', '$cname', 20030211143833, 'Will appear almost anywhere.')"; 
$sqla[ 116 ] = " INSERT INTO CRMsettings VALUES (2, 'logo', '$logo', 20030218182208, 'Location of your company logo (small, GIF or JPEG). *NONE* disables the logo.')"; 
$sqla[ 117 ] = " INSERT INTO CRMsettings VALUES (3, 'department', 'Customer Care', 20020727115335, 'Short department discription. Will appear in USERS overview only, to tell the CRM wheter or not somebody is a member of the departement and therefore his/her name will not appaer in the managementinterface.')"; 
$sqla[ 118 ] = " INSERT INTO CRMsettings VALUES (4, 'admpassword', '*NONE*', 20020520162029, 'Administration password, *NONE* disables the authentication at all.')"; 
$sqla[ 119 ] = " INSERT INTO CRMsettings VALUES (5, 'mipassword', '*NONE*', 20020520184155, 'Management Information password, *NONE* disables the authentication at all.')"; 
$sqla[ 120 ] = " INSERT INTO CRMsettings VALUES (6, 'managementinterface', 'off', 20020520210325, 'When set to on, users authenticated as a limited user will only see the restricted managementinterface with very limited priviledges. Opposite to on is off.')"; 
$sqla[ 121 ] = " INSERT INTO CRMsettings VALUES (7, 'admemail', '$admemail', 20030226120032, 'The administrators email-addres.')"; 
$sqla[ 122 ] = " INSERT INTO CRMsettings VALUES (8, 'cronpassword', '', 20020520180654, 'The password used by the HTTP-GET crond job (duedate-notify-cron.php)')"; 
$sqla[ 123 ] = " INSERT INTO CRMsettings VALUES (9, 'timeout', '20', 00000000000000, 'Number of minutes before a user is automatically logged off when there is no activity')"; 
$sqla[ 124 ] = " INSERT INTO CRMsettings VALUES (10, 'Company', 'ABC Ltd, 10 unknow street, 11 NW1 London UK, Tel 0123456, Fax 0123456', 20030226112718, 'Your company anagraphic')"; 
$sqla[ 125 ] = " INSERT INTO CRMsettings VALUES (11, 'Logistic unit', 'DEF Logistics Ltd, 11 NW1 London UK, Tel 0123456', 20030226111926, 'Eventual different anagraphic of your logistic unit')"; 
$sqla[ 126 ] = " INSERT INTO CRMsettings VALUES (12,'MySql Dump Path','C:/Programmi/EasyPHP/mysql/bin/',20030326092222,'The path to your MySqlDump.exe. Needed to backup the database.')";


$sqla[ 127 ] = " INSERT INTO CRMusers VALUES (1, 'admin', 'admin', 1, 1, '', 0, 0, 0, 'info@customer-touch.com', 'english', '', '', '', '', '', '')"; 
$sqla[128] = "INSERT INTO CRMusers (us_name, us_password, us_type, us_active, us_email) VALUES('$fstaccount','$fstpwd1', 1, 1,'$admemail')";

$sqla[ 129 ] = "INSERT INTO CRMorg_type VALUES (1, 'To Do', 'em.icon.approve.gif')";
$sqla[ 130 ] = "INSERT INTO CRMorg_type VALUES (2, 'Meeting', 'em.icon.bigsmile.gif')";
$sqla[ 131 ] = "INSERT INTO CRMorg_type VALUES (3, 'Note', 'em.icon.blush.gif')";
$sqla[ 132 ] = "INSERT INTO CRMorg_type VALUES (4, 'Reminder', 'em.icon.dead.gif')";


	return($sqla);

} // end func


/*	$link = mysql_pconnect("localhost", "mysql_user", "mysql_password")
        or exit("Could not connect");

    if (mysql_create_db("my_db")) {
        print ("Database created successfully\n");
    } else {
        printf ("Error creating database: %s\n", mysql_error ());
    }
*/
function get_perms($file) {
   $p_bin = substr(decbin(@fileperms($file)), -9) ;
   $p_arr = explode(".", substr(chunk_split($p_bin, 1,
"."), 0, 17)) ;
   $perms = ""; $i = 0;
   foreach ($p_arr as $this) { 
      $p_char = ( $i%3==0 ? "r" : ( $i%3==1 ? "w" :
"x" ) ); 
      $perms .= ( $this=="1" ? $p_char : "-" ) . (
$i%3==2 ? " " : "" );
      $i++;
   }
   return $perms;
}
?>
