<?

// ----------------------------------------------------------------------
// CUSTOMER-TOUCH CRM
// Copyright (C) 2003 by the Customer-Touch Development Team.
// http://www.customer-touch.com
// ----------------------------------------------------------------------
// Based on:
// CRM COMMERCIAL TRACKING TOOL - http://sourceforge.net/projects/crm-ctt/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html or
// take a look in the Doc directory
// ----------------------------------------------------------------------
// Original Author of this file: Alessandro Grassi
// ----------------------------------------------------------------------


// **********************************************************************
// LANGUAGE FILE FOR ENGLISH 
// **********************************************************************


// ----------------------------------------------------------------------
// CREATED BY ALESSANDRO GRASSI - ctcrm at users.sourceforge.net
// DATE: 25/03/2003
// NOTE: a.grassi@customer-touch.com
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// TRANSLATED BY XXXXXXXXXXXX - XXXX at users.sourceforge.net
// DATE: XX/XX/XXXX
// NOTE: 
// ----------------------------------------------------------------------





//general
    $arr[DISC_INACT1]="You were disconnected because of $timeout of inactivity.";
    $arr[DISC_INACT_RELOG]="You were disconnected. Please, reinsert access parameters";
    $arr[PL_RELOG]="Please, insert your username and password";
    $arr[USR_NAME]="Username";
    $arr[SAVE_USR]="Save Username";
    $arr[DEL_USR]="Clear Username";
    $arr[SAVE_PWD]="Save Password";
    $arr[DEL_PWD]="Clear Password";
    $arr[DISCLAIM_LOGIN]="*This settings will be stored or deleted on your Pc for next session.";
    $arr[LOGIN]="Login";
    $arr[YES]="Yes";
    $arr[NO]="No";
    $arr[PREV_PAGE]="[back to previous page]";    
    $arr[PRINT_BTN]="Print";
    $arr[NOT_SET]="Not setted";
    $arr[ALL]="All";
    $arr[DATA_FOR]="dd-mm-yyyy";
    $arr[GO]="GO";
    $arr[ERR_PWD]="Password incorrected. Retry again, please.";
    $arr[INS_PWD]="Please, insert your admin password:";

//status names
    $arr[S1]="Open";
    $arr[S2]="Waiting for validation";
    $arr[S3]="Rettified";
    $arr[S4]="Refused";
    $arr[S5]="Close";
    $arr[S11]="Deleted";

//priority names
    $arr[P1]="Low";
    $arr[P2]="Medium";
    $arr[P3]="High";
    $arr[P4]="Critical";

//modules names
    $arr[MO_GR1]="Main Tools";
    $arr[MO_GR2]="Advanced Tools";

    $arr[MO1]="Add an Entity";
    $arr[MO2]="Entities Brief List";
    $arr[MO3]="Detailed Entities";
    $arr[MO4]="Brief list Deleted Entities";
    $arr[MO5]="Entities Validation";
    $arr[MO6]="Entities Validation";
    $arr[MO7]="Data Export";
    $arr[MO8]="Clients";
    $arr[MO9]="Statistics";
    $arr[MO10]="Graphs";
    $arr[MO11]="Products";
    $arr[MO12]="Administration";
    $arr[MO13]="Help";
    $arr[MO14]="About";
    $arr[MO15]="Exit";
    $arr[MO16]="Database Backup";

    $arr[MOD1]="Add an Entity concerning a certain client";
    $arr[MOD2]="Work on brief list to solve entities";
    $arr[MOD3]="Advanced search on Entities";
    $arr[MOD4]="Take a look on the list of entity solved and deleted";
    $arr[MOD5]="Check and Validate desk user job (first validator)";
    $arr[MOD6]="Check and Validate desk user job(second validator)";
    $arr[MOD7]="Export data (CSV)";
    $arr[MOD8]="Admin Clients: check, add, edit clients in db";
    $arr[MOD9]="Statistical and graphs tool for management";
    $arr[MOD10]="Statistical and graphs tool of webserver usage";
    $arr[MOD11]="Admin Products catalog";
    $arr[MOD12]="Administration interface for software and system";
    $arr[MOD13]="Help on program usage";
    $arr[MOD14]="Disclaimer";
    $arr[MOD15]="Exit the application";
    $arr[MOD16]="Make a Database Backup";

//index.php
    $arr[WELCOME]="Welcome to";
    $arr[BRIEF]="BRIEF OVERVIEW";
    $arr[THIS_MOM]="In this moment there are";
    $arr[USERS]="users";
    $arr[USERS_ADM_EN_COUNT]="Users working on";
     $arr[ENTITIES_FOR]="entities for";
    $arr[CLIENTS_IN_DB]="clients present in the database.";
    $arr[TOPPR0]="Entities dues for today:";    
    $arr[WELCOME3]="Today there are not entities to close, but there are"; 
    $arr[ENT_OP_NO_AW]="opened entities not in awaiting closure status";
    $arr[ASS_TO]="assigned to";
    $arr[TOT_EN_STAT]="Total entities";
    $arr[OF_STAT]="of wich";
    $arr[OPENED]="Opened";
    $arr[AWAITING]="Awaiting closure";
    $arr[REJECTED]="Rejected";
    $arr[CLOSED]="Closed";
    $arr[DELETED]="Deleted <br>&nbsp;&nbsp;&nbsp;&nbsp;(non-existing included)";
    $arr[EXPIRED]="Expired";
    $arr[NON_EXISTING_AND_DEL]="Non-existing <br>&nbsp;&nbsp;&nbsp;&nbsp;(deleted included)";
    $arr[ADD_TH_WK]="Entities added this week ($weeknumber)";
    $arr[CL_TH_WK]="Entities closed this week ($weeknumber)";
    $arr[ADD_TH_M]="Entities added this month ($month)";
    $arr[CL_TH_M]="Entities closed this month ($month)";
    $arr[ANNUAL_SM]="Annual summary";
    $arr[ON_AVER]="On";
    $arr[AN_EN]="worked entities, the open-time, time between the closure of an entity and the opening of a new one is";
    $arr[DDAYS]="days.<br>";
    $arr[DATA_OBT1]="Data obtained using <u>all</u> opened entities in database, during <u>all</u> the year. There was";
    $arr[DATA_OBT2]="entities closed before the due date.";


//entry.php
    $arr[TITLE_ENTR1]="Entity Brief List";
    $arr[TITLE_ENTR2]="For a better consultation, please take a look on Entity Advanced Panel<br>Double click to get more information of an entity";
    $arr[PROGR_ID]="Progressiv ID";
    $arr[CLIENT]="Client";
    $arr[OPEN_BY]="Opened by";
    $arr[ASS_TY]="Assigned to";
    $arr[STATUS]="Status";
    $arr[PRIORITY]="Priority";
    $arr[TITLE]="Title";
    $arr[DUEDATE]="Due date";
    $arr[ALARM]="Alarm";
    $arr[ACTIONS]="Actions";
    $arr[NO_DUEDATE]="not setted";
    $arr[NO_ALARM]="not setted";
    $arr[EDIT_EN_SIMB]="E";
    $arr[EDIT_EN_ALT]="Edit";
    $arr[ALARM_EN_SIMB]="A";
    $arr[ALARM_ALT]="Set alarm";
    $arr[DELETE_FRO_LIS_SIM]="D";
    $arr[DELETE_FRO_LIS_ALT]="Delete from list";
    $arr[VALIDATION_SIM]="V";
    $arr[VALIDATION_ALT]="Submit to validation";
    $arr[DELETE_FRO_LIS_SIM]="X";
    $arr[DELETE_FRO_LIS_ALT]="Delete from list";
    $arr[SURE_ALERT]="Are you sure? Click OK for deleting this entity from the list. The entity will be saved on database for statistic purposes.";


//editclose.php //editclose.php & entityclose.php
    $arr[TITLE_ENTR_EC1]="Brief list of problems you have to validate";


//edit.php ; edit2.php ; edit3.php
    $arr[BEEN_CLOSED]="Entity have been closed an the ID is";
    $arr[STEP2]="Add an an entity in Customer-Touch CRM database: step 2 of 2. In this window you can change progressiv ID, if oyu need. Update only if you make some changes.";
    $arr[ERR_NO_ACTION]="ERROR. No action setted. Nothing added.";
    $arr[CONFIRME_DEL]="Confirme deletion";
    $arr[IMPOSS_DEL]="Until entity will not be closed, is not possible delete it!";
    $arr[CLICK_TO_DEL]="Click to delete the entity";
    $arr[AL_HAVE_T_SEL_CUST]="You have to select a client first!";
    $arr[AL_HAVE_T_FILL_TITL]="You have to fill the field Title!";
    $arr[AL_HAVE_T_FILL_DESCR]="You have to fill the field Description!";
    $arr[STEP1]="Add an Entity in Customer-Touch CRM database: step 1 of 2";
    $arr[ARE_WORKING_ON_EN]="You are working on entity";
    $arr[CREATED_BY_USR]="created by user";
    $arr[ASSIGN_TO_USR]="assigned to user";
    $arr[ENT_STATUS]="Status of entity:";
    $arr[CREATED_DATE]="created";
    $arr[LAST_UPD_ON]="last update";
    $arr[EN_CLOSED_ON]="This entity have been closed on";
    $arr[SEARCH_SELECT_CUSTOMER]="Search/select a customer";
    $arr[NEW_EN_COMP]="New Entity: fill the form";
    $arr[VAL_COMM]="Comment (inserted by validators)";
    $arr[ED_TITL]="Title";
    $arr[ED_SOLVE_BY]="Duedate";
    $arr[ED_ERR_GEN]="Who made the error?";
    $arr[ED_TRASP]="Trasport";
    $arr[GO_ON_EN_FILL]="Go ahead in filling entity";
    $arr[SAVE_UPD_EN]="Save or Update the entity";
    $arr[EN_COMMENT]="Insert a comment (will be visualized to the Desk User)";
    $arr[EN_SET_ALARM_ALT]="Set an alarm for this entity";


//customers.php
    $arr[CL_INDB]="Clients present in database:";
    $arr[CL_SELECT]="[select a client]";
    $arr[CL_FASTNAME]="Fast name :";
    $arr[CL_ADD_DEST]="Add more adresses for the customer";
    $arr[CL_SELLMAN]="Sell man";
    $arr[CL_SELL_INDB]="Sell man in DB";
    $arr[CL_SELL_ASS]="Associated Sell Man";
    $arr[CL_SELL_DELETE]="Delete this customer";


//del.php
    $arr[DEL_TITLE]="Entities worked, validated and deleted from brief list";


//db_bkp.php
    $arr[DB_BKP_PASS]="Please, insert passwowd to backup the database";
    $arr[DB_BKP_BTN]="Execute the backup";


//csv.php
    $arr[CSV_SLCT_FIELDS]="Selects wished fields for export";
    $arr[CSV_DAY_LAST]="Day last change";
    $arr[CSV_TIME_LAST]="Time last change";
    $arr[CSV_CLOSEDATE]="Closedate";
    $arr[CSV_WAITING]="Waiting";
    $arr[CSV_DESCR]="Description";
    $arr[CSV_KIND]="kind of separation";
    $arr[CSV_GENERATE]="Make the CSV file";
    $arr[CSV_AL1]="When you will see the download window, please select 'open file";
    $arr[CSV_AL2]="This window could appear two times. If happens click 'open' again.";
    $arr[TITLE_CSV]="Export data module";
    

//navbar.php
    $arr[TODAY_IS]="Today is ".date("d/m/Y")." time ".date("H:i") . ".";
    $arr[THERE_ARE]="There are";
    $arr[OPEN_EN]="Opened entities";

//navbar2.php
    $arr[NO_OPEN]="There are not opened entities";


//send_email.php
    $arr[TO_EMAIL]="To";
    $arr[OBJ_EMAIL]="Object";
    $arr[BODY_EMAIL]="Text";
    $arr[PR_EMAIL]="Priority";
    $arr[URG_EMAIL]="Urgent";
    $arr[HI_EMAIL]="High";
    $arr[MD_EMAIL]="Medium";
    $arr[LW_EMAIL]="Low";
    $arr[LL_EMAIL]="Very Low";
    $arr[ATCH_EMAIL]="Attach file";
    $arr[LEN_EMAIL]="lenght";
    $arr[SD_EMAIL]="Send mail";
    $arr[CLOSE]="Close";


//module.php
    $arr[MDL_IN_DB]="Modules present in database:";
    $arr[MDL_SELECT]="Select a module";
    $arr[MDL_NAME]="Module name :";
    $arr[MDL_DSCR]="Description :";
    $arr[MDL_GR]="Group :";
    $arr[MDL_ICO]="Icon :";
    $arr[MDL_ORD]="Order :";
    $arr[MDL_IN_MEN]="In menu :";
    $arr[MDL_SAVE]="Apply changes";
    $arr[MDL_DELETE]="Delete this module";


//summary.php
    $arr[DET_ISS]="entity detailed list";
    $arr[SEARC_FOR]="Search for";
    $arr[OP]="Operator";
    $arr[EXP]="Duedate";
    $arr[WAIT]="Waiting";
    $arr[INCL_CONT]="Include content";
    $arr[INCL_DEL]="Include deleted entity";
    $arr[DOWN_CSV]="Download result in csv";
    $arr[BRIEF_OW]="Brief overview";
    $arr[SEARCH_TXT]="Search text in entity";
    $arr[RUN_SEARCH]="Search";
    $arr[CANCEL]="Clear Form";
    $arr[PLEASE]="Please select your search criteria";
    $arr[NO_SEARCH]="No result, please redifine your search criteria";
    $arr[AL_DATE]="Allarm data";
    $arr[ENT_ATT]="This entity has files attached";
    $arr[FILENAME]="Filename";
    $arr[FILESIZE]="Filesize";
    $arr[CR_DATA]="Creation date";
    $arr[OPEN_WIN]="Open new window";
    $arr[DELETE]="Delete";
    $arr[ALT_MOD]="Edit entity";
    $arr[ALT_OPEN_WIN]="Modify in a new window";
    $arr[ALT_DELETE]="Delete entity closed and approved";
    $arr[FOUND_EN]="founded entity";
    $arr[SEL]="Select";
    $arr[SEL_TRA]="* Select *";
    $arr[ADDRESS]="Address";
    $arr[PRODUCT]="Products";
    $arr[PRD_BTN]="E";
    $arr[NEW_ACTION]="Set a new action";
    $arr[TYPE_ACTION]="Action type";
    $arr[DONE]="Done";
    $arr[VIEW]="View";
    $arr[ENT_VAL]="Validate entity";
    $arr[ENT_RJ]="Reject entity";


//stats.php
    $arr[ST_TITLE]="Reporting Module";
    $arr[ST_END]="End of report";
    $arr[ST_POSS_RD]="Choose a Report";
    $arr[ST_SEL_REC]="Select a Report to show";
    $arr[ST_SUMM]="General summary";
    $arr[ST_USR_PR]="Entities per users";
    $arr[ST_PR_ASS]="Entities per assignee";
    $arr[ST_ASS_OW]="Entities autoassigned";
    $arr[ST_RETT]="Rettified entities";
    $arr[ST_VAL]="Entities in awaiting";
    $arr[ST_CUST]="Entities per client";
    $arr[ST_RET]="Entities in retard";
    $arr[ST_CLEAR]="Clear list";
    $arr[OM_EN]="Rettified were not counted";
    $arr[ST_COMPR]="Not assigned or assignables also counted";
    $arr[ST_AND_ASS_TO]="and assigned to";
    $arr[ST_AU_AS]="Auto-Assigned";
    $arr[ST_SELF_ASS]="Other users that have opened an entity have it assigned to themself";
    $arr[ST_RET2]="Retards";
    $arr[ST_AV]="On average";
    $arr[ST_ALL]="of all entities in retard";
    $arr[ST_NOT_HAVE]="Other users dont have entities in retard";
    $arr[ST_EN_OP]="entities have been rettified.";
    $arr[ST_OF_ALL_VAL]="of all entities is in awaiting closure.";


//products.php
    $arr[PR_IN_CAT]="Products in catalog";
    $arr[PR_SEL]="Select a product";
    $arr[PR_NAME]="Product name";
    $arr[PR_DESCR]="Product description";
    $arr[PR_IMG]="Product image";
    $arr[PR_DEL]="Delete Product";

//admin.php
    $arr[ADM_TITLE]="Administration Tools";
    $arr[ADM_OPTION]="Select between options";
    $arr[ADM_SYS_VAR]="Admin System Settings";
    $arr[ADM_FILES]="View Files";
    $arr[ADM_CL_CLOSED]="Clean Brieflist from Deleted Entities";
    $arr[ADM_HELP]="Add / Edit Help Topics";
    $arr[ADM_DEL_REC]="Delete Record from Db (phisically)";
    $arr[ADM_USERS]="Admin Users";
    $arr[ADM_USERS_FIELDS]="Admin Users Fields";
    $arr[ADM_CLIENTS_FIELDS]="Admin Customers Fields";
    $arr[ADM_ENTITY_FIELDS]="Admin Entities Fields";
    $arr[ADM_PRODUCTS]="Admin Products Catalogue";
    $arr[ADM_MODULES]="Admin Modules";
    $arr[ADM_ROLES]="Admin Roles";
    $arr[ADM_ACTION_TYPE]="Admin Action Type";
    $arr[ADM_ERR_TYPE]="Admin Error Type";
    $arr[ADM_LOG]="Last 100 Log Entries";
    $arr[ADM_ACT_SETT]="Actual system settings";
    $arr[ADM_OPTION]="Option";
    $arr[ADM_VALUE]="Value";
    $arr[ADM_DSCR]="Description";
    $arr[ADM_UPDATE]="Change values";
    $arr[ADM_FILES_TITLE]="Viewing files, sorted by filesize descending";
    $arr[ADM_FID]="FileID";
    $arr[ADM_F_NAME]="Filename";
    $arr[ADM_F_CR_DATE]="Creation Date";
    $arr[ADM_F_SIZE]="Size";
    $arr[ADM_F_TYPE]="Type";
    $arr[ADM_F_JUMP]="Jump";
    $arr[ADM_F_DEL]="Delete";
    $arr[ADM_F_REF]="Referenced";
    $arr[ADM_EN_ST]="Parent entity status";  
    $arr[ADM_F_TOTAL]="Total";


//date.php
    $arr[DATE_TITL1]="Setting date for the entity";
    $arr[DATE_ALERT]="This entity have allready an alarm date setted! You can edit it in this interface.";
    $arr[DATE_ACT]="Actual alarm date";
    $arr[DATE_ALERT2]="The default email setted are the ones of owner and assignee";
    $arr[DATE_ALERT3]="Because of any alarm was setted, the duedate is suggested by the application as alarm date";
    $arr[DATE_ALERT4]="Use the comma to separate the email adresses (if more than one per line),"; 
    $arr[DATE_ALERT5]="delete an adress if you dont want to send him an alarm.";
    $arr[DATE_MORE_ADD]="More adresses";
    $arr[DATE_ADRESSES]="Adresses";
    $arr[DATE_AL_DATE]="Alarm date";
    $arr[DATE_SET]="Set Alerm";
    $arr[DATE_SUGG]="suggested";


//user_fields.php
    $arr[UF_PRESENT_INDB]="User fields present in database";
    $arr[UF_SELECT_FIELD]="Select a field";
    $arr[UF_FIELD_NAME]="Field name";
    $arr[UF_FIELD_KIND]="Field type";
    $arr[UF_FIELD_AFTER]="After field";
    $arr[UF_DELETE_FIELD]="Delete this field";


//entity_fields.php
    $arr[EF_PRESENT_INDB]="Entity fields present in database";


//action_admin.php
    $arr[AA_PRESENT_INDB]="Actions present in database";
    $arr[AA_SELECT]="Select an action";
    $arr[AA_ACTION_NAME]="Action name";
    $arr[AA_DELETE]="Delete this action";


//error_admin.php
    $arr[EA_PRESENT_INDB]="Errors present in database";
    $arr[EA_ERROR_NAME]="Error name";
    $arr[EA_SELECT]="Select an error";
    $arr[EA_DELETE]="Delete this error";


//users.php
    $arr[US_PRESENT_INDB]="Users in database";
    $arr[US_SELECT]="Select user";
    $arr[US_US_FIELDS_LINK]="Admin user fields";
    $arr[US_PWD]="Password";
    $arr[US_PWD2]="Retype Password";
    $arr[US_ROLE]="Role";
    $arr[US_ACTIVE]="Active";
    $arr[US_LANG]="Language";
    $arr[US_EMAIL]="E-mail";
    $arr[US_DEL]="Delete this user";


//customer_fields.php
    $arr[CF_PRESENT_INDB]="Users fields present in database";


//role.php
    $arr[ROLE_PRESENT_INDB]="Ruoles present in database";
    $arr[ROLE_NAME]="Role name";
    $arr[ROLE_DESCR]="Role description";
    $arr[ROLE_ACC]="Access to";
    $arr[ROLE_SELECT]="Select a role";
    $arr[ROLE_DELETE]="Delete this role";


//action.php
    $arr[ACT_TITLE]="Action description";
    $arr[ACT_KIND]="Kind";
    $arr[ACT_OPER]="Operator";
    $arr[ACT_DESCR]="Description";
    $arr[ACT_PROGRAM]="Programmed for";
    $arr[ACT_CAL_BUTT]="C";
    $arr[ACT_EX_NOW]="Do it now";
    $arr[ACT_EX_LATER]="Save and do in future";
    $arr[ACT_DATE_ALERT]="Please, fill Data field.";
    $arr[ACT_DATE_ALERT2]="Date have invalid format and have not been inserted.";
    $arr[ACT_SET_DATE]="Set date";
    $arr[ACT_EXEXUTED]="Done";
    $arr[ACT_EXECUTED_DATE]="Excution date";



//eof    
?>
