<?

// ----------------------------------------------------------------------
// CUSTOMER-TOUCH CRM
// Copyright (C) 2003 by the Customer-Touch Development Team.
// http://www.customer-touch.com
// ----------------------------------------------------------------------
// Based on:
// CRM COMMERCIAL TRACKING TOOL - http://sourceforge.net/projects/crm-ctt/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html or
// take a look in the Doc directory
// ----------------------------------------------------------------------
// Original Author of this file: Alessandro Grassi
// ----------------------------------------------------------------------


// **********************************************************************
// LANGUAGE FILE FOR ITALIAN
// **********************************************************************


// ----------------------------------------------------------------------
// CREATED BY ALESSANDRO GRASSI - ctcrm at users.sourceforge.net
// DATE: 25/03/2003
// NOTE: a.grassi@customer-touch.com
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// TRANSLATED BY DANIELE DECOL - dcdnl at users.sourceforge.net
// DATE: 25/03/2003
// NOTE: d.decol@customer-touch.com
// ----------------------------------------------------------------------



//general
    $arr[DISC_INACT1]="Sei stato disconnesso poich sono trascorsi $timeout minuti senza attivit.";
    $arr[DISC_INACT_RELOG]="Sei stato disconnesso. Per cortesia, reinserisci i parametri d'accesso";
    $arr[PL_RELOG]="Per favore, inserisca il suo Nome Utente e la sua Password personale";
    $arr[USR_NAME]="Nome utente";
    $arr[SAVE_USR]="Salva Nome Utente";
    $arr[DEL_USR]="Cancella Nome Utente*";
    $arr[SAVE_PWD]="Salva Password";
    $arr[DEL_PWD]="Cancella Password";
    $arr[DISCLAIM_LOGIN]="*Questi settaggi verranno salvati o cancellati sul tuo Pc per la sessione successiva.";
    $arr[LOGIN]="Entra";
    $arr[YES]="Si";
    $arr[NO]="No";
    $arr[PREV_PAGE]="[alla pagina precedente]";
    $arr[PRINT_BTN]="Stampa";
    $arr[NOT_SET]="Non impostato";
    $arr[ALL]="Tutti";
    $arr[DATA_FOR]="gg-mm-aaaa";
    $arr[GO]="VAI";
    $arr[ERR_PWD]="Password errata. Riprova.";
    $arr[INS_PWD]="Per cortesia, inserisci la password:";


//status names
    $arr[S1]="Aperto";
    $arr[S2]="In attesa di validazione";
    $arr[S3]="Rettificato";
    $arr[S4]="Rifiutato";
    $arr[S5]="Chiuso";
    $arr[S11]="Cancellato";


//priority names
    $arr[P1]="Bassa";
    $arr[P2]="Media";
    $arr[P3]="Alta";
    $arr[P4]="Critica";


//modules names
    $arr[MO_GR1]="Strumenti Principali";
    $arr[MO_GR2]="Strumenti Avanzati";

    $arr[MO1]="Aggiungi un problema";
    $arr[MO2]="Brief List dei Problemi";
    $arr[MO3]="Dettaglio Problemi";
    $arr[MO4]="Brief list Problemi cancellati";
    $arr[MO5]="Validazione Problemi";
    $arr[MO6]="Validazione Problemi";
    $arr[MO7]="Esportazione dati";
    $arr[MO8]="Clienti";
    $arr[MO9]="Statistiche";
    $arr[MO10]="Grafici di utilizzo";
    $arr[MO11]="Prodotti";
    $arr[MO12]="Amministrazione";
    $arr[MO13]="Guida rapida";
    $arr[MO14]="Informazioni";
    $arr[MO15]="Esci";
    $arr[MO16]="Database Backup";
    $arr[MO17]="Calendario";

    $arr[MOD1]="Aggiunge un problema relativo ad un cliente";
    $arr[MOD2]="Guarda la brief list dei problemi da risolvere";
    $arr[MOD3]="Gestisci in maniera dettagliata i problemi da risolvere";
    $arr[MOD4]="Guarda la brief list dei problemi risolti e cancellati";
    $arr[MOD5]="Permetti ai Desk Users di cancellare i Problemi chiusi. ";
    $arr[MOD6]="Permetti ai Desk Users di cancellare i Problemi chiusi. ";
    $arr[MOD7]="Esegui delle esportazioni di dati per usi vari (CSV)";
    $arr[MOD8]="Gestione anagrafica clienti: guarda, aggiungi e modifica i clienti in database";
    $arr[MOD9]="Strumenti di statistica avanzati e grafici per il management";
    $arr[MOD10]="Statistiche e grafici sull'utilizzazione del webserver";
    $arr[MOD11]="Catalogo prodotti";
    $arr[MOD12]="Funzioni di amministrazione del software e delle variabili di sistema";
    $arr[MOD13]="Help sui principali comanti del programma";
    $arr[MOD14]="Disclaimer";
    $arr[MOD15]="Chiudi ed esci dal programma";
    $arr[MOD16]="Esegui il Backup del database";
    $arr[MOD17]="Organizza il tuo calendario";


//index.php
    $arr[WELCOME]="Benvenuto nel software";
    $arr[BRIEF]="BRIEF DEL GIORNO";
    $arr[THIS_MOM]="In questo momento ci sono";
    $arr[USERS]="utenti";
    $arr[USERS_ADM_EN_COUNT]="utenti che stanno amministrando";
     $arr[ENTITIES_FOR]="Problemi per i";
    $arr[CLIENTS_IN_DB]="clienti presenti nel database.";
    $arr[TOPPR0]="Problemi che vanno risolti entro la giornata:";    
    $arr[WELCOME3]="Oggi non ci sono problemi da chiudere, ma ci sono"; 
    $arr[ENT_OP_NO_AW]="problemi aperti e non sottoposti a validazione";
    $arr[ASS_TO]="assegnato a";    
    $arr[TOT_EN_STAT]="Totale problemi";
    $arr[OF_STAT]="di cui";
    $arr[OPENED]="Aperti";
    $arr[AWAITING]="In attesa di validazione";
    $arr[REJECTED]="Rifiutati";
    $arr[CLOSED]="Chiusi";
    $arr[DELETED]="Cancellati <br>&nbsp;&nbsp;&nbsp;&nbsp;(inclusi i rettificati)";
    $arr[EXPIRED]="Scaduti";
    $arr[NON_EXISTING_AND_DEL]="Rettificati <br>&nbsp;&nbsp;&nbsp;&nbsp;(inclusi quelli cancellati)";
    $arr[ADD_TH_WK]="Problemi aggiunti questa settimana ($weeknumber)";
    $arr[CL_TH_WK]="Problemi chiusi questa settimana ($weeknumber)";
    $arr[ADD_TH_M]="Problemi aperti in questo mese ($month)";
    $arr[CL_TH_M]="Problemi chiusi in questo mese ($month)";
    $arr[ANNUAL_SM]="Sommario annuale";
    $arr[ON_AVER]="Sulla media di ";
    $arr[AN_EN]="problemi analizzati, l'open-time, tempo di chiusura del problema prima dell'apertura di uno nuovo  stato di ";
    $arr[DDAYS]="giorni.<br>";
    $arr[DATA_OBT1]="Dati ottenuti usando <u>tutti</u> i problemi aperti presenti in db, durante <u>tutto</u> l'anno. Ci sono stati";
    $arr[DATA_OBT2]="problemi chiusi prima dello scadere.";


//entry.php
    $arr[TITLE_ENTR1]="Brief List Problemi";
    $arr[TITLE_ENTR2]="Per una consultazione dettagliata utilizza la sezione Dettaglio Problemi<br>Clicca due volte sul problema per ottenere maggiori informazioni";
    $arr[PROGR_ID]="Progressivo";
    $arr[CLIENT]="Cliente";
    $arr[OPEN_BY]="Aperto da";
    $arr[ASS_TY]="Assegnato a";
    $arr[STATUS]="Stato";
    $arr[PRIORITY]="Priorit";
    $arr[TITLE]="Titolo";
    $arr[DUEDATE]="Da chiudere entro";
    $arr[ALARM]="Allarme";
    $arr[ACTIONS]="Azioni";
    $arr[NO_DUEDATE]="non impostato";
    $arr[NO_ALARM]="nessuno";
    $arr[EDIT_EN_SIMB]="M";
    $arr[EDIT_EN_ALT]="Modifica";
    $arr[ALARM_EN_SIMB]="A";
    $arr[ALARM_ALT]="Setta allarme";
    $arr[DELETE_FRO_LIS_SIM]="E";
    $arr[DELETE_FRO_LIS_ALT]="Elimina dalla lista";
    $arr[VALIDATION_SIM]="V";
    $arr[VALIDATION_ALT]="Sottoponi a validazione";
    $arr[DELETE_FRO_LIS_SIM]="X";
    $arr[DELETE_FRO_LIS_ALT]="Elimina dalla lista";
    $arr[SURE_ALERT]="Sei sicuro? Clicca OK per cancellare dalla lista questo problema. Il problema sar comunque salvato nel database a fini di statistica.";


//editclose.php & entityclose.php
    $arr[TITLE_ENTR_EC1]="Brief list dei problemi sottoposti alla tua validazione";


//edit.php ; edit2.php ; edit3.php
    $arr[BEEN_CLOSED]="Il problema  stato salvato ed il suo ID progressivo ";
    $arr[STEP1]="Aggiungi un Problema nel Database Customer-Touch CRM: passo 2 di 2. In questa finestra  possibile cambiare il progressivo suggerito. Aggiorna solo se esegui delle modifiche.";
    $arr[ERR_NO_ACTION]="ERRORE. Nessuna azione impostata. Non  stato aggiunto nulla.";
    $arr[CONFIRME_DEL]="Conferma la cancellazione";
    $arr[IMPOSS_DEL]="Finch il problema non verr chiuso non  possibile cancellarlo!";
    $arr[CLICK_TO_DEL]="Clicca per cancellare il problema";
    $arr[AL_HAVE_T_SEL_CUST]="Devi selezionare un cliente!";
    $arr[AL_HAVE_T_FILL_TITL]="Devi compilare il campo Tipologia/Titolo!";
    $arr[AL_HAVE_T_FILL_DESCR]="Per cortesia, descrivi il problema nel campo di testo principale!";
    $arr[STEP1]="Aggiungi un Problema nel Database Customer-Touch CRM: passo 1 di 2";
    $arr[ARE_WORKING_ON_EN]="Stai lavorando sul problema";
    $arr[CREATED_BY_USR]="creato dall'utente";
    $arr[ASSIGN_TO_USR]="assegnato all'utente";
    $arr[ENT_STATUS]="Stato del problema:";
    $arr[CREATED_DATE]="creato in data";
    $arr[LAST_UPD_ON]="ultimo aggiornamento il";
    $arr[EN_CLOSED_ON]="Questo problema  stato chiuso il";
    $arr[SEARCH_SELECT_CUSTOMER]="Ricerca/Seleziona un cliente";
    $arr[NEW_EN_COMP]="Nuovo Problema: compilazione scheda";
    $arr[VAL_COMM]="Commento (inserito dal resp. operativo o qualit)";
    $arr[ED_TITL]="Tipologia, titolo";
    $arr[ED_SOLVE_BY]="Da risolvere entro";
    $arr[ED_ERR_GEN]="A chi  attribuibile l'errore?";
    $arr[ED_TRASP]="Trasportatore";
    $arr[GO_ON_EN_FILL]="Prosegui nella compilazione del problema";
    $arr[SAVE_UPD_EN]="Salva o aggiorna il problema";
    $arr[EN_COMMENT]="Inserisci commento (verr visualizzato dall'operatore)";
    $arr[EN_SET_ALARM_ALT]="Imposta un allarme per questo problema";


//customers.php
    $arr[CL_INDB]="Clienti presenti nel database:";
    $arr[CL_SELECT]="[seleziona un cliente]";
    $arr[CL_FASTNAME]="Nome breve :";
    $arr[CL_ADD_DEST]="Aggiungi altre destinazioni";
    $arr[CL_SELLMAN]="Agente";
    $arr[CL_SELL_INDB]="Agenti nel DB";
    $arr[CL_SELL_ASS]="Agenti associati";
    $arr[CL_SELL_DELETE]="Cancella questo cliente";


//del.php
    $arr[DEL_TITLE]="Problemi processati, validati e chiusi presenti nel database";


//db_bkp.php
    $arr[DB_BKP_PASS]="Per cortesia, inserisci la password per poter eseguire il backup";
    $arr[DB_BKP_BTN]="Esegui Backup del Database";


//csv.php
    $arr[CSV_SLCT_FIELDS]="Seleziona i campi che desideri esportare";
    $arr[CSV_DAY_LAST]="Giorno ultima modifica";
    $arr[CSV_TIME_LAST]="Ora ultima modifica";
    $arr[CSV_CLOSEDATE]="Data chiusura";
    $arr[CSV_WAITING]="In attesa";
    $arr[CSV_DESCR]="Descrizione";
    $arr[CSV_KIND]="tipologia di separazione campi";
    $arr[CSV_GENERATE]="Genera file di export";
    $arr[CSV_AL1]="Quando ti apparir la finestra di download, scegli 'apri il file";
    $arr[CSV_AL2]="Questa finestra potrebbe apparirti due volte. Se accade clicca 'apri' ancora.";
    $arr[TITLE_CSV]="Modulo di esportazione dati";



//navbar.php
    $arr[TODAY_IS]="Oggi  il ".date("d/m/Y")." e sono le ore ".date("H:i") . ".";
    $arr[THERE_ARE]="Ci sono";
    $arr[OPEN_EN]="Problemi aperti";    


//navbar2.php
    $arr[NO_OPEN]="Non ci sono problemi aperti";


//send_email.php
    $arr[TO_EMAIL]="Destinatario";
    $arr[OBJ_EMAIL]="Oggetto";
    $arr[BODY_EMAIL]="Testo";
    $arr[PR_EMAIL]="Priorit";
    $arr[URG_EMAIL]="Urgente";
    $arr[HI_EMAIL]="Alta";
    $arr[MD_EMAIL]="Media";
    $arr[LW_EMAIL]="Bassa";
    $arr[LL_EMAIL]="Molto Bassa";
    $arr[ATCH_EMAIL]="Allega file";
    $arr[LEN_EMAIL]="dimensione";
    $arr[SD_EMAIL]="Invia mail";
    $arr[CLOSE]="Chiudi";


//module.php
    $arr[MDL_IN_DB]="Moduli presenti nel database:";
    $arr[MDL_SELECT]="Seleziona un modulo";
    $arr[MDL_NAME]="Nome modulo :";
    $arr[MDL_DSCR]="Descrizione :";
    $arr[MDL_GR]="Gruppo :";
    $arr[MDL_ICO]="Icona :";
    $arr[MDL_ORD]="Ordine :";
    $arr[MDL_IN_MEN]="Nel menu :";
    $arr[MDL_SAVE]="Applica modifiche";
    $arr[MDL_DELETE]="Cancella questo modulo";


//summary.php
    $arr[DET_ISS]="dettaglio problemi";
    $arr[SEARC_FOR]="Esegui ricerca per";
    $arr[OP]="Operatore";
    $arr[EXP]="Scadenza";
    $arr[WAIT]="In attesa";
    $arr[INCL_CONT]="Includi il contenuto";
    $arr[INCL_DEL]="Includi problemi cancellati dalla lista";
    $arr[DOWN_CSV]="Scarica il risultato come csv";
    $arr[BRIEF_OW]="Brief overview";
    $arr[SEARCH_TXT]="Ricerca testo nel problema";
    $arr[RUN_SEARCH]="Esegui ricerca";
    $arr[CANCEL]="Annulla";
    $arr[PLEASE]="Per favore, seleziona i tuoi criteri di ricerca";
    $arr[NO_SEARCH]="La ricerca  non ha prodotto alcun esito. Per cortesia, specifica meglio i criteri di ricerca";
    $arr[AL_DATE]="Data allarme";
    $arr[ENT_ATT]="Questo problema ha degli allegati";
    $arr[FILENAME]="Nome file";
    $arr[FILESIZE]="Dimensioni file";
    $arr[CR_DATA]="Data creazione";
    $arr[OPEN_WIN]="Apri nuova finestra";
    $arr[DELETE]="Elimina";
    $arr[ALT_MOD]="Modifica il problema";
    $arr[ALT_OPEN_WIN]="Aggiorna e modifica in una nuova finestra";
    $arr[ALT_DELETE]="Cancella il problema chiuso ed approvato";
    $arr[FOUND_EN]="Problemi trovati";
    $arr[SEL]="Seleziona";
    $arr[SEL_TRA]="* Seleziona *";
    $arr[ADDRESS]="Indirizzo";
    $arr[PRODUCT]="Prodotti";
    $arr[PRD_BTN]="M";
    $arr[NEW_ACTION]="Imposta una nuova azione";
    $arr[TYPE_ACTION]="Tipologia di azione";
    $arr[DONE]="Eseguita";
    $arr[VIEW]="Visualizza";
    $arr[ENT_VAL]="Valida il problema";
    $arr[ENT_RJ]="Risottoponi il problema";


//stats.php
    $arr[ST_TITLE]="Modulo di Reporting";
    $arr[ST_END]="Fine del report";
    $arr[ST_POSS_RD]="Record possibili";
    $arr[ST_SEL_REC]="Seleziona i report da visualizzare";
    $arr[ST_SUMM]="Sommario generale";
    $arr[ST_USR_PR]="Problemi per utente";
    $arr[ST_PR_ASS]="Problemi per assegnazione";
    $arr[ST_ASS_OW]="Problemi assegnati e posseduti da un utente";
    $arr[ST_RETT]="Problemi rettificati";
    $arr[ST_VAL]="Problemi in attesa di validazione";
    $arr[ST_CUST]="Problemi per cliente";
    $arr[ST_RET]="Problemi in ritardo su assegnazione";
    $arr[ST_CLEAR]="Pulisci lista";
    $arr[OM_EN]="I rettificati sono stati omessi";
    $arr[ST_COMPR]="Compresi i problemi non ancora assegnati e non assegnabili";
    $arr[ST_AND_ASS_TO]="e assegnati a";
    $arr[ST_AU_AS]="Auto-Assegnati";
    $arr[ST_SELF_ASS]="Gli altri utenti che hanno aperto un problema non se lo sono assegnato";
    $arr[ST_RET2]="Ritardi";
    $arr[ST_AV]="In media il";
    $arr[ST_ALL]="di tutti i problemi in ritardo";
    $arr[ST_NOT_HAVE]="Altri utenti non hanno problemi scaduti";
    $arr[ST_EN_OP]="problemi aperti sono stati rettificati";
    $arr[ST_OF_ALL_VAL]="di tutti i problemi  in attesa di validazione.";


//products.php
    $arr[PR_IN_CAT]="Prodotti nel tuo catalogo";
    $arr[PR_SEL]="Seleziona un prodotto";
    $arr[PR_NAME]="Nome del prodotto";
    $arr[PR_DESCR]="Descrizione prodotto";
    $arr[PR_IMG]="Immagine prodotto";
    $arr[PR_DEL]="Cancella prodotto";


//admin.php
    $arr[ADM_TITLE]="Strumenti di Amministrazione";
    $arr[ADM_OPTION]="Seleziona una delle opzioni";
    $arr[ADM_SYS_VAR]="Amministra le variabili di sistema";
    $arr[ADM_FILES]="Visualizza files caricati";
    $arr[ADM_CL_CLOSED]="Pulisci la brieflist dai problemi chiusi";
    $arr[ADM_HELP]="Aggiungi / Modifica gli help topics";
    $arr[ADM_DEL_REC]="Elimina fisicamente un record dal db";
    $arr[ADM_USERS]="Amministra Utenti";
    $arr[ADM_USERS_FIELDS]="Amministra i campi utente";
    $arr[ADM_CLIENTS_FIELDS]="Amministra i campi cliente";
    $arr[ADM_ENTITY_FIELDS]="Amministra i campi dei problemi";
    $arr[ADM_PRODUCTS]="Amministra catalogo prodotti";
    $arr[ADM_MODULES]="Amministra moduli";
    $arr[ADM_ROLES]="Amministra ruoli";
    $arr[ADM_ACTION_TYPE]="Amministra tipologie azioni";
    $arr[ADM_ERR_TYPE]="Amministra tipologie errori";
    $arr[ADM_LOG]="Ultime 100 log entries";
    $arr[ADM_ACT_SETT]="Attuali impostazioni di sistema";
    $arr[ADM_OPTION]="Opzione";
    $arr[ADM_VALUE]="Valore";
    $arr[ADM_DSCR]="Descrizione";
    $arr[ADM_UPDATE]="Modifica valori";
    $arr[ADM_FILES_TITLE]="Visione dei files, mostrati per ordine discendente rispetto alla grandezza";
    $arr[ADM_FID]="File ID";
    $arr[ADM_F_NAME]="Nome file";
    $arr[ADM_F_CR_DATE]="Data creazione";
    $arr[ADM_F_SIZE]="Dimensione";
    $arr[ADM_F_TYPE]="Tipo";
    $arr[ADM_F_JUMP]="Problema correlato";
    $arr[ADM_F_DEL]="Cancella";
    $arr[ADM_F_REF]="Approvato";
    $arr[ADM_EN_ST]="Stato del problema correlato";  
    $arr[ADM_F_TOTAL]="Totale";


//date.php
    $arr[DATE_TITL1]="Settaggio della data per il problema";
    $arr[DATE_ALERT]="Questo problema ha gi una data di allarme! Puoi cambiarla utilizzando questa interfaccia.";
    $arr[DATE_ACT]="Attuale data dell'allarme";
    $arr[DATE_ALERT2]="Le email impostate di default sono quelle di chi ha aperto il problema e della persona a cui  stato affidato";
    $arr[DATE_ALERT3]="Poich questo problema non ha alcun allarme fino ad ora, il parametro da terminare entro..  suggerito come data dell'allarme";
    $arr[DATE_ALERT4]="Utilizza la virgola per separare gli indirizzi email (se superiori a uno per linea),"; 
    $arr[DATE_ALERT5]="cancella un indirizzo se non vuoi che venga inviato l'allarme a quella persona.";
    $arr[DATE_MORE_ADD]="Indirizzi aggiuntivi";
    $arr[DATE_ADRESSES]="Indirizzi";
    $arr[DATE_AL_DATE]="Data allarme";
    $arr[DATE_SET]="Imposta allarme";
    $arr[DATE_SUGG]="suggerita";


//user_fields.php
    $arr[UF_PRESENT_INDB]="Campi utente presenti nel database";
    $arr[UF_SELECT_FIELD]="Seleziona un campo";
    $arr[UF_FIELD_NAME]="Nome campo";
    $arr[UF_FIELD_KIND]="Tipologia campo";
    $arr[UF_FIELD_AFTER]="Dopo ilcampo";
    $arr[UF_DELETE_FIELD]="Cancella questo campo";


//entity_fields.php
    $arr[EF_PRESENT_INDB]="Campi Problema presenti nel database";


//action_admin.php
    $arr[AA_PRESENT_INDB]="Azioni presenti nell'applicazione";
    $arr[AA_SELECT]="Seleziona un'azione";
    $arr[AA_ACTION_NAME]="Nome dell'azione";
    $arr[AA_DELETE]="Cancella l'azione";


//error_admin.php
    $arr[EA_PRESENT_INDB]="Tipologie di errori presenti nel database";
    $arr[EA_ERROR_NAME]="Nome dell'errore";
    $arr[EA_SELECT]="Seleziona un errore";
    $arr[EA_DELETE]="Cancella questo errore";


//users.php
    $arr[US_PRESENT_INDB]="Utenti presenti nel database";
    $arr[US_SELECT]="Seleziona un utente";
    $arr[US_US_FIELDS_LINK]="Amministra campi utente";
    $arr[US_PWD]="Password";
    $arr[US_PWD2]="Retype Password";
    $arr[US_ROLE]="Ruolo";
    $arr[US_ACTIVE]="Attivo";
    $arr[US_LANG]="Lingua";
    $arr[US_EMAIL]="E-mail";
    $arr[US_DEL]="Cancella questo utente";


//customer_fields.php
    $arr[CF_PRESENT_INDB]="Campi cliente presenti nel database";


//role.php
    $arr[ROLE_PRESENT_INDB]="Ruoli presenti nel database";
    $arr[ROLE_NAME]="Nome ruolo";
    $arr[ROLE_DESCR]="Descrizione ruolo";
    $arr[ROLE_ACC]="Accede a";
    $arr[ROLE_SELECT]="Seleziona un ruolo";
    $arr[ROLE_DELETE]="Cancella questo ruolo";


//action.php
    $arr[ACT_TITLE]="Descrizione azione";
    $arr[ACT_KIND]="Tipologia";
    $arr[ACT_OPER]="Operatore";
    $arr[ACT_DESCR]="Descrizione";
    $arr[ACT_PROGRAM]="Programmata per il";
    $arr[ACT_CAL_BUTT]="C";
    $arr[ACT_EX_NOW]="Esegui adesso";
    $arr[ACT_EX_LATER]="Salva ed esegui in futuro";
    $arr[ACT_DATE_ALERT]="Per cortesia, compila il campo Data.";
    $arr[ACT_DATE_ALERT2]="La data inserita non  in un formato valido. La data non  stata inserita.";
    $arr[ACT_SET_DATE]="Settata per il";
    $arr[ACT_EXEXUTED]="Eseguita";
    $arr[ACT_EXECUTED_DATE]="Data esecuzione";


//eof
?>


